/*****************************************************************************
 * main.c: main xawdecode source
 *****************************************************************************
 * $Id: main.c,v 1.257 2004/06/16 22:08:04 pingus77 Exp $
 *****************************************************************************
 * Copyright (C) 2001 Keuleu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************
 *
 * This software was based on xawtv. Those portions are
 * Copyright (C) 1997 Gerd Knorr <kraxel@cs.tu-berlin.de>
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/utsname.h>
#include <sys/stat.h>
#include <dlfcn.h>
#include <dirent.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/mman.h>

#include "config.h"

#define ALEVT_ENABLED 1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xmd.h>
#include <X11/keysym.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>

#include "writefile.h"
#include "mixer.h"
#include "channel.h"
#include "channels.h"
#include "strtab.h"
#include "grab.h"
#include "x11.h"
#include "toolbox.h"
#include "wmhooks.h"
#include "lirc.h"
#include "file.h"
#include "cpu_accel.h"
#include "memcpy.h"
#include "deinterlace.h"
#include "divx.h"
#include "divx_ui.h"
#include "subtitles_ui.h"
#include "popup_ui.h"
#include "xscreensaver.h"
#include "plugin.h"
#include "xawdecode.h"
#include "xfreeparams_ui.h"
#include "blackborder.h"

#ifdef HAVE_XPM
# include <X11/xpm.h>
#endif

#ifdef HAVE_XPM
# include "xawdecode.xpm"
#endif

#ifdef HAVE_LIBXXF86DGA
# ifdef  HAVE_XFREE86_4            // In fact have XFree86 4.X.X
#  include <X11/Xproto.h>
#  define XF86DGA_MAJOR_VERSION XDGA_MAJOR_VERSION
#  define XF86DGA_MINOR_VERSION XDGA_MINOR_VERSION
# endif
# include <X11/extensions/xf86dga.h>
# include <X11/extensions/xf86dgastr.h>
#endif

#ifdef HAVE_LIBXXF86VM
# include <X11/extensions/xf86vmode.h>
# include <X11/extensions/xf86vmstr.h>
int vm_count;
XF86VidModeModeInfo **vm_modelines;
#endif

#ifdef HAVE_LIBXINERAMA
# include <X11/extensions/Xinerama.h>
XineramaScreenInfo *xinerama;
int nxinerama;
#endif

#ifdef HAVE_LIBXDPMS
# include <X11/extensions/dpms.h>
# ifndef  HAVE_XFREE86_4
// XFree 3.3.x has'nt prototypes for this ...
Bool DPMSQueryExtension (Display *, int *, int *);
Bool DPMSCapable (Display *);
Status DPMSInfo (Display *, CARD16 *, BOOL *);
Status DPMSEnable (Display *);
Status DPMSDisable (Display *);
# endif
#endif

#ifdef ALEVT_ENABLED
# include "alevt.h"
# include "alevtparams_ui.h"
extern int real_alevt_in_use;
extern void stop_subtitles();
extern void start_subtitles();
#endif

#ifdef HAVE_VIDEO_XV
static int xvtv = 0, xvtv_overlay = -1;
extern char* xv_video_name;
int cmdline_xv_video_port = 0;
#endif

#ifdef HAVE_XV
int disable_xv = 0;
int cmdline_xv_img_port = 0;
#else
int disable_xv = 1;
#endif

#ifdef HAVE_BKTR
extern int bktr_swap, bktr_yuvbug, bktr_mode, bktr_read;
#endif

#ifdef USE_LIBXOSD
#include <xosd.h>
static xosd *osd_main, *osd_vtx, *osd_bar;
char *font;
char *font_vtx;
char *colour;
static int libxosd_ok = 1;
static int libxosd = 0;
static int screen_width;
static int screen_height;
#endif

/*-------------------------------------------------------------------------*/

#define ONSCREEN_TIME       6000
#define TITLE_TIME          6000
#define KEYPAD_TIME	    6000
#define ZAP_TIME            5000
#define CAP_TIME              20
#define SCAN_TIME            100
#define MUTE_TIME            100    //0.1 sec mute when switching channels
#define WIDTH_INC             64
#define HEIGHT_INC            48
#define VIDMODE_DELAY        100    // 0.1 sec
#define NB_SUBPAGENO          23

/*--- public variables ----------------------------------------------------*/

static int divx_pixmap_format = 0;
static int v4l2 = 0;
static int keypad_value = -1, doublekey = -1, doublekey_firstisone = -1;
static int subpageno = 0;

int force_visual = -1, force_depth = -1;
int overlay_format;
int res_mode = 0;
int direct_video = 0, direct_xsize = 0;
static int memfd, video_size = 0;
int noDGA = 0;
int alevt1st = 0;
int have_config = 0;
int pointer_on = 1, on_skip = 0;
int debug = 0;
int fs = 0;
int de = 1;
int fs_width, fs_height, fs_xoff, fs_yoff;
int pix_width= 128, pix_height = 96;
int bpp = 0;
int hwscan = 0;
int have_MMX = 0;
int memcpy_method = MEMCPY_PROBE;
int force_capture = -1;
int stay = 0;
int staytmp = 0;
int subactive = 0;
int zap_start, zap_fast;
int lirc;
int xfree_ext = 1;
int have_dga = 0;
int have_vm = 0;
int submethod;
int unactsubpage = 0;
int xawpopup = 1;
int oldswitch = 0;

static char *plugdef = "libxawdecode.so", *plugfile;

char *res_modes[] = {"bright", "contrast", "color", "hue"};
char *video_base = NULL;
char alevtarg [256];
char alevtinit [256];
char *ppmfile;
char *jpegfile;
char modename[64];
char *progname;
char *subtitles_pageno_str = NULL;

static void keypad_timeout(XtPointer client_data, XtIntervalId *id);

void set_volume (void);
void set_subtitles_pageno(char*);
void *hPlugin = NULL;

PLUGIN *plugin = NULL;
Boolean (*idle_grabdisplay) (XtPointer data);
Atom wm_protocols[2], xawtv_remote, xawtv_station, xa_deactivate;
XtWorkProcId idle_id = 0;
XtIntervalId title_timer, audio_timer, zap_timer, scan_timer, on_timer, keypad_timer;
static XtIntervalId xscreensaver_timer;

XtAppContext app_context;
Widget app_shell        = NULL;
Widget tv               = NULL;
Widget opt_shell        = NULL;
Widget opt_paned        = NULL;
Widget chan_shell       = NULL;
Widget conf_shell       = NULL;
Widget on_shell         = NULL;
Widget on_label         = NULL;
Widget vtx_shell        = NULL;
Widget vtx_label        = NULL;
Widget c_norm           = NULL;
Widget c_input          = NULL;
Widget c_freq           = NULL;
Widget c_audio          = NULL;
Widget c_cap            = NULL;
Widget c_deinterlace    = NULL;
Widget c_stayontop      = NULL;
Widget c_decoration     = NULL;
Widget divx_shell       = NULL;
Widget divxaudio_shell  = NULL;
Widget streamparams_shell= NULL;
Widget c_record         = NULL;
Widget c_subpageno      = NULL;
Widget c_alevt          = NULL;
Widget c_zap            = NULL;
Widget c_graball        = NULL;
Widget c_simple_actions = NULL;
Widget c_togglesub      = NULL;
Widget s_bright         = NULL;
Widget l_bright         = NULL;
Widget s_color          = NULL;
Widget l_color          = NULL;
Widget s_hue            = NULL;
Widget l_hue            = NULL;
Widget s_contrast       = NULL;
Widget l_contrast       = NULL;
Widget s_volume         = NULL;
Widget l_volume         = NULL;
Widget chan_viewport    = NULL;
Widget chan_box         = NULL;

#ifdef USE_LIBXOSD
Widget c_xosdaction     = NULL;
#endif

/*--- drivers -------------------------------------------------------------*/

#ifdef HAVE_DEVFS
struct device_t device = {"/dev/v4l/video", "/dev/v4l/vbi"};
#else
struct device_t device = {"/dev/video", "/dev/vbi"};
#endif

char *mixer = "line";

int nbufs_default=3;

extern struct GRABBER grab_v4l;
extern struct GRABBER grab_v4l2;
extern struct GRABBER grab_dummy;
#ifdef HAVE_BKTR
extern struct GRABBER grab_bktr;
#endif
#ifdef HAVE_VIDEO_XV
extern struct GRABBER grab_xv;
#endif
extern struct GRABBER grab_avi;
extern char *avifilename;
extern int avibench,avinoaudioout,avi_audio_fragments,avi_audio_sizefragment;

struct GRABBER *grabbers[] = {
  &grab_v4l2,
  &grab_v4l,
#ifdef HAVE_BKTR
  &grab_bktr,
#endif
#ifdef HAVE_VIDEO_XV
  &grab_xv,
#endif
  // uncomment the following line to test without a TV-card
  &grab_dummy,
  &grab_avi,
};

int grabber;

/*--- channels ------------------------------------------------------------*/

struct STRTAB *cmenu = NULL;
char title[256];

int cur_color;
int cur_bright;
int cur_hue;
int cur_contrast;
int cur_capture;
int cur_deinterlace = DEINTERLACE_NONE;

int cur_mute = 0;
int cur_volume = 100;

/*--- actions -------------------------------------------------------------*/

/* conf.c */
extern void create_editorwin ();
extern void editor_station_switched ();
extern void editor_list_update ();
extern void save_cb (Widget widget, XtPointer clientdata, XtPointer call_data);

void CloseMainAction (Widget, XEvent *, String *, Cardinal *);
void ShowtimeAction (Widget, XEvent *, String *, Cardinal *);
#ifdef USE_LIBXOSD
void XosdAction(Widget, XEvent *, String *, Cardinal *);
void Show_bar(int ,int);
#endif
void SetResAction (Widget, XEvent *, String *, Cardinal *);
void SetBgAction (Widget, XEvent *, String *, Cardinal *);
void SetShadowAction (Widget, XEvent *, String *, Cardinal *);
void SetChannelAction (Widget, XEvent *, String *, Cardinal *);
void SetSourceAction (Widget, XEvent *, String *, Cardinal *);
void TuneAction (Widget, XEvent *, String *, Cardinal *);
void ScanAction (Widget, XEvent *, String *, Cardinal *);
void ChannelAction (Widget, XEvent *, String *, Cardinal *);
void VolumeAction (Widget, XEvent *, String *, Cardinal *);
void PointerAction (Widget, XEvent *, String *, Cardinal *);
void FullScreenAction (Widget, XEvent *, String *, Cardinal *);
void OptionsAction (Widget, XEvent *, String *, Cardinal *);
void ChannelsAction (Widget, XEvent *, String *, Cardinal *);
void EditorAction (Widget, XEvent *, String *, Cardinal *);
void RemoteAction (Widget, XEvent *, String *, Cardinal *);
void ZapAction (Widget, XEvent *, String *, Cardinal *);
void SubPageAction (Widget, XEvent *, String *, Cardinal *);
void SnapAction (Widget, XEvent *, String *, Cardinal *);
void AleVTAction (Widget, XEvent *, String *, Cardinal *);
void AleVTParamsAction (Widget, XEvent *, String *, Cardinal *);
void XFreeParamsAction (Widget, XEvent *, String *, Cardinal *);
void StreamParamsAction (Widget, XEvent *, String *, Cardinal *);
void SetBlackborderAction (Widget , XEvent *, String *, Cardinal *);
void StayOnTopAction (Widget, XEvent *, String *, Cardinal *);
void DecorationAction (Widget, XEvent *, String *, Cardinal *);
void DeinterlaceAction (Widget, XEvent *, String *, Cardinal *);
void SubtitlesPagenoAction (Widget, XEvent *, String *, Cardinal *);
void UnSubtitlesPagenoAction (Widget, XEvent *, String *, Cardinal *);
void autoscroll (Widget, XEvent *, String *, Cardinal *);
void ToggleSubAction (Widget, XEvent *, String *, Cardinal *);
void RecordMovieAction (Widget, XEvent *, String *, Cardinal *);

XtActionsRec actionTable[] = {
  {"CloseMain", CloseMainAction},
  {"SetRes", SetResAction},
  {"SetBg", SetBgAction},
  {"SetShadow", SetShadowAction},
  {"SetChannel", SetChannelAction},
  {"Tune", TuneAction},
  {"Scan", ScanAction},
  {"Channel", ChannelAction},
  {"Pointer", PointerAction},
  {"FullScreen", FullScreenAction},
  {"Options", OptionsAction},
  {"Channels", ChannelsAction},
  {"Editor", EditorAction},
  {"Remote", RemoteAction},
  {"Zap", ZapAction},
  {"SubPage", SubPageAction},
  {"Snap", SnapAction},
  {"Help", help_AC},
  {"Hide", HidePopup}, 
  {"Hide2", HidePopup2},   
  {"Showtime", ShowtimeAction},
#ifdef USE_LIBXOSD
  {"Xosd",XosdAction},
#endif
  {"Volume", VolumeAction},
  {"AleVT", AleVTAction},
  {"AleVTParams", AleVTParamsAction},
  {"XFreeParams", XFreeParamsAction},
  {"StreamParams", StreamParamsAction},
  {"SetBlackborder", SetBlackborderAction},
  {"StayOnTop", StayOnTopAction},
  {"Decoration", DecorationAction},
  {"RecordMovie", RecordMovieAction},
  {"DivX", DivXAction},
  {"DivXAudio", DivXAudioAction},
  {"Deinterlace", DeinterlaceAction},
  {"SubtitlesPageno", SubtitlesPagenoAction},
  {"UnSubtitlesPageno", UnSubtitlesPagenoAction},
  {"autoscroll", autoscroll},
  {"ToggleSub", ToggleSubAction}
};

static struct STRTAB stereo[] = {
  {0, "auto"},
  {1, "mono"},
  {2, "stereo"},
  {-1, NULL}
};

static struct STRTAB cap_list[] = {
  {CAPTURE_OFF, "off"},
  {CAPTURE_OVERLAY, "overlay"},
  {CAPTURE_GRABDISPLAY, "grabdisplay"},
  {-1, NULL}
};

struct STRTAB deinterlace_list[] = {
  {DEINTERLACE_NONE,     "None"},
  {DEINTERLACE_BOB,      "Bob"},
  {DEINTERLACE_WEAVE,    "Weave"},
  {DEINTERLACE_GREEDY,   "Greedy"},
  {DEINTERLACE_ONEFIELD, "One Field"},
  {DEINTERLACE_LINEARBLEND, "Linear Blend"},
  {-1, NULL}
};

struct STRTAB yes_no_list[] = {
  {WMHOOKS_YES, "Yes"},
  {WMHOOKS_NO,  "No"},
  {-1, NULL}
};

static struct STRTAB grab_list[] = {
  {0, "Grab a Window Image (ppm)"},
  {1, "Grab a Fullscreen Image (ppm)"},
#ifdef HAVE_LIBJPEG
  {2, "Grab a Window Image (jpeg)"},
  {3, "Grab a Fullscreen Image (jpeg)"},
#endif
  {-1, NULL}
};

struct STRTAB simple_actions_list[] = {
  {0, "Audio (un)mute (A)"},
  {1, "Audio (un)mute + TVMUTE (Shift+A)"},  
  {2, "Show time (H)"},
  {3, "Mouse Pointer hidden/visible (M)"},
  {4, "Fullscreen on/off (F)"},
  {-1, NULL}
};

struct STRTAB record_list[] = {
  {RECORD_START, "Record Start"},
  {RECORD_STOP,  "Record Stop"},
  {RECORD_VIDEO_PARAM, "Video Parameters"},
  {RECORD_AUDIO_PARAM, "Audio Parameters"},
  {STREAM_SERVER_PARAM, "Streaming Parameters"},
  {-1, NULL}
};

struct STRTAB alevt_list[] = {
  {0,  "AleVT Start/Stop"},
  {1, "AleVT Parameters"},
  {-1, NULL}
};

struct STRTAB zap_list[] = {
  {0, "Slow Zapping"},
  {1, "Fast Zapping"},
  {-1, NULL}
};

struct STRTAB visuals_list[] = {
  {StaticGray,   "StaticGray"},
  {GrayScale,    "GrayScale"},
  {StaticColor,  "StaticColor"},
  {PseudoColor,  "PseudoColor"},
  {TrueColor,    "TrueColor"},
  {DirectColor,  "DirectColor"},
  {-1, NULL}
};

static struct STRTAB subpageno_list[] = {
  {0,  "all"},
  {1,  "888"},
  {2,  "777"},
  {3,  "150"},
  {4,  "149"},
  {5,  "151"},
  {6,  "160"},
  {7,  "161"},
  {8,  "690"},
  {9,  "778"},
  {10, "784"},
  {11, "884"},
  {12, "885"},
  {13, "886"},
  {14, "887"},
  {15, "889"},
  {16, "890"},
  {17, "891"},
  {18, "892"},
  {19, "893"},
  {20, "895"},
  {21, "897"},
  {22, "Other"},
  {-1, NULL}
};

static char *help_msg[] = {
"       -b depth\n"
"              force xawdecode into depth bits color depth.  Might\n"
"              be  needed for 24/32 bits. However the best perfor\n"
"              mances in grabdisplay mode are achieved with  a  16\n"
"              bits color depth.\n",

"       -f     startup in fullscreen mode.\n",

"       -nowd  startup with no window decoration.\n",

"       -m     startup with mouse pointer turned off.\n",

"       -n     don't read the config file ($HOME/.xawdecode/xawde\n"
"              coderc).\n",

"       -o filename\n"
"              set output filename for ppm  grabbing  (default  is\n"
"              snap000.ppm)\n",

"       -j filename\n"
"              set  output  filename for jpeg grabbing (default is\n"
"              snap000.jpeg)\n",

"       -v level\n"
"              Be verbose, level may be 0 (default), 1 or  2.   It\n"
"              exists just for debugging. If no level is provided,\n"
"              a level of 1 is assumed.\n",

"       -x     disable, the usage of XFree  extensions  (DGA,  Vid\n"
"              Mode).\n",

"       -d     disable the usage of XFree DGA extension.\n",

"       -directvideo\n"
"              enables direct video mode for grabdisplay.\n",

"       -D adr set framebuffer address to adr.\n",

"       -Dw width\n"
"              sets the width of framebuffer.\n",

"       -c video device\n"
"              video4linux video device. For devfs enabled systems, default  is\n"
"              /dev/v4l/video  or /dev/v4l/video0, in that order. For non devfs\n"
"              systems,  default  is   /dev/video   or   /dev/video/video0   or\n"
"              /dev/video0, in that order.  Note that on /proc enabled systems,\n"
"              video device detection is automagic.\n",

"       -C vbi device\n"
"              video4linux vbi device. For devfs enabled  systems,  default  is\n"
"              /dev/v4l/vbi or /dev/v4l/vbi0, in that order. For non devfs sys-\n"
"              tems, default is /dev/vbi or  /dev/video/vbi  or  /dev/vbi0,  in\n"
"              that  order.   Note  that  on  /proc enabled systems, vbi device\n"
"              detection is automagic.\n"

"       -noxv | -no-xv\n"
"              disables  the  Xvideo support if it was com\n"
"              piled in.\n",

"       -xvport number\n"
"              set Xvideo Image port (defaults to the first\n"
"              usable  if  Xvideo  is available). A usuable\n"
"              one is one which does support YUY2 format.\n",

"       -hwscan\n"
"              print a list of available devices.\n",

"       -noplugin\n"
"              disable any plugin installed.\n",

"       -plugin pathfile\n"
"              enable a specific plugin.\n",

"       -probe_memcpy\n"
"              force benchmarking of different possibilities\n"
"              for a fast memcpy function.\n",

"       -rec_fps fps\n"
"              set recording framerate (default=25.0)\n",

"       -rec_display on|off\n"
"              set display mode during recording (default=on)\n",

"       -rec_width width\n"
"              set width of the recording video (default=384)\n",

"       -rec_height height\n"
"              set height of the recording video (default=384)\n",

"       -rec_videobr br\n"
"              set recording video bitrate to br kbit/s (default=800)\n",

"       -rec_stereo on|off\n"
"              activate stero mode (default=off)\n",

"       -rec_audiobuf size\n"
"              set the size of the audio buffer (default=1764)\n",

"       -rec_fragments number\n"
"              set the number of audio fragments (default=48)\n",

"       -rec_fragmentsize size\n"
"              set the size of the audio fragment (default=2048)\n",

"       -rec_mp3 on|off\n"
"              activates audio MP3 encoding\n",

"       -rec_mp3cbr br\n"
"              activate MP3 CBR and set bitrate to br kbit/s\n"
"              (default=activated, 128kbit/s)\n",

"       -rec_mp3vbr quality\n"
"              activate MP3 VBR and set compressing quality (0=best, 9=worst)\n"
"              (default=deactivated, quality=8)\n",

"       -rec_vcodec xvid|ffmpeg_mpeg4|ffmpeg_mpeg1|ffmpeg_huffyuv|divx4linux|uncompressed\n"
"              set recording video codec\n",

"       -rec_maxgap\n"
"              set recording max gap between audio and video in seconds\n"
"              (default = 0.08 second)\n",

"       -rec_delay\n"
"              set recording delay between audio and video in seconds\n"
"              (default = 0.00 second)\n",

"       -rec_sub on|off\n"
"              indicates if subtitles are recorded\n"
"              (the subtitles are recorded in MPlayer's MPsub format).\n",

"       -rec_chg on|off\n"
"              allows channel changes during recording.\n",

"       -rec_filename\n"
"              set the avi filename\n"
"              (default=divx_path/movie-channel-date.avi)\n",

"       -rec_stream on|off\n"
"              enables http export of the recording\n"
"              (xawdecode will act as a http stream server)\n",

"       -rec_http_port\n"
"              set the port of the http stream (default=63427)\n",

"       -e \"cmd_1; cmd_2; cmd_3;...cmd_n\" \n"
"              execute the commands at the beginning of execution\n",

"       -v4l2  forces v4l2 driver.\n",

"       -v4l1  forces the v4l1 old driver.\n",

#ifdef HAVE_VIDEO_XV
"       -xvtv\n"
"              communicates with the TV-card through the X-server\n"
"              (needs Xvideo, and your TV-card must be recognized by X).\n",

"       -xvtv_overlay on|off\n"
"              uses XVideo for overlay if available\n"
"              (default=on with v4l2 and video4linux).\n",

"       -xvtvport number\n"
"              set Xvideo Video port (defaults to the first usable).\n",
#endif

"       -novbi does not open the teletext device.\n",

"       -capture overlay|grabdisplay|off\n"
"              forces capture mode.\n",

"       -nbufs nbufs\n"
"              sets the number of kernel-buffered frames (default=3).\n",

"       -capt_width width\n"
"              sets the maximum width of the grabbed frames (default=768)\n",

"       -capt_height height\n"
"              sets the maximum height of the grabbed frames (default=576)\n",

"       -force_capt_width width\n"
"              sets the width of the grabbed frames (default=0=notforcing)\n",

"       -force_capt_height height\n"
"              sets the height of the grabbed frames (default=0=notforcing)\n",

"       -force_visual StaticGray|PseudoColor|TrueColor\n"
"              forces to use X11 visual.\n",

"       -force_depth 8|15|16|24|32\n"
"              forces to use specified X11 depth.\n",

"       -avi filename.avi\n"
"              reads frames from filename.avi\n",

"       -avibench\n"
"              stops when the end of the avi is reached\n"
"              and diplays some statistics on  CPU  usage\n",

"       -avi_audiofragments number\n"
"              set the number of audio fragments for avi reading (default=2)\n",

"       -avi_audiofragmentsize size\n"
"              set the size of audio fragments for avi reading (default=2048)\n",

"       -avinoaudioout\n"
"              does not output audio during avi reading\n",

#ifdef USE_LIBXOSD
"       -xosd  use xosd library to display osd (still in developpement)\n",
#endif

"       -sub on|off\n"
"              activates/deactivates subtitles (default=off)\n",

"       -subpageno number|all\n"
"              sets pageno of subtitles\n",

#ifdef HAVE_ALSA
"       -noalsa\n"
"              does not use alsa native functions to manage sound\n",
#endif

"       -restoresnd on|off\n"
"              indicates  if  xawdecode  restores the initial sound settings on\n"
"              exit.  (default=off)\n",

#ifdef HAVE_BKTR
"       -bktr_swap\n"
"              swap bytes for yuv format\n",

"       -bktr_mode nr\n"
"              chooses a capture format by its number\n"
"              (see supported formats in xawdecode output)\n",

"       -bktr_yuvbug\n"
"              convert rgb to yuv by processor\n"
"              (only with XVideo, slow,\n"
"               use it only if your driver is buggy)\n" ,

"       -bktr_read\n"
"              uses read instead of mmap\n"
"              (slow, use it only if your driver is buggy)\n",
#endif

"       -doublekey on/off\n"
"              enables double keys (default=on if more than 10 stations)\n",

"       -doublekey_firstisone on/off\n"
"              the first station has number 1, and not 0, needed for doublekey\n"
"              (default=off except if lirc-key-1 is mapped to keypad 0\n"
"               or the hotkey of the first channel is 1, KP_1 or KP_End)\n",

"       -noxawpopup\n"
"              to disable xaw popup\n",

"       -oldswitch\n"
"              Old XFree resolution switching method used in fullscreen mode\n",

"       -ybar nr\n"
"              set height of the black borders for a total height of 1000\n"
"              nr=125 for 16:9, nr=200 for 20:9 (default=0)\n",

#ifdef ALEVT_ENABLED
"	-alevt_arg\n"
"	You must write the arguments between two quotation marks\n"
"\n"
"	    --help or -h\n"
"	    --version or -v\n"
"           --debug or -debug\n"
"	    -copyright or - \n"
"	    -editor or -ed \n"
"	    -display or -d <dpy>					$DISPLAY\n"
"	    -geometry or -g <geo>					41x25\n"
"	    -finetune or -f <-4..4|auto>				0\n"
"	    -child or -c ppp[.ss]\n"
"	    [-parent] or -p ppp[.ss]					900\n"
"	    -[no]erc or -[n]e						enabled\n"
"	    -[no]bell or -[n]b                 				enabled\n"
"	    -charset or -latin latin-1/2/koi8-r/koi/iso8859-7/el	latin-1\n"
"\n"
"  	Order is important!  Each page number opens a new window\n"
"  	with the previously given geometry, device, and display.\n"
"\n"
"  	ppp[.ss] stands for a page number and an optional subpage \n"
"  	number (ie 123.4).  If the subpage number is omitted the\n"
"  	first transmitted subpage is shown.\n"
"\n"
"  	The -child option requires a parent window. So, it\n"
"  	must be preceeded bya parent or another child window\n",
#endif

"       -h     prints a brief usage message and exits.\n",

NULL};

char *cmd = NULL;

/*--- externs ------------------------------------------------------------*/
extern divx_t divx;
extern void setfps(double);
extern void init_socket(void);
extern void close_socket(void);
extern void do_command(char *);
extern int width_capture, height_capture;
extern int width_capture_max, height_capture_max;
extern int eventmap_checkfirstisone(void);
extern char *sendername;

/*--- EXIT functions----------------------------------------------------------------*/

Boolean
ExitWP (XtPointer client_data)
{
  /* exit if the application is idle,
   * i.e. all the DestroyCallback's are called.
   */
  exit (0);
}

void
ExitCB (Widget widget, XtPointer client_data, XtPointer calldata)
{

  if (is_divx_in_progress())
    divx_stop();

  if (plugin != NULL)
    plugin->close();

  if (hPlugin)
    dlclose(hPlugin);
  plugin = NULL;

#ifdef ALEVT_ENABLED
  if (real_alevt_in_use)
    stop_alevt();

  stop_subtitles();
#endif

  if (-1 != cur_sender)
    save_last_channel(cur_sender);

  grabbers[grabber]->grab_close ();
  if (have_mixer)
    mixer_close ();

  video_overlay (NULL);
  video_close ();

#ifdef HAVE_LIBXXF86DGA
  if(have_dga && direct_video)
    XF86DGADirectVideoLL(dpy, XDefaultScreen (dpy), 0);
#endif

  if(direct_video) {munmap(video_base, video_size); close(memfd);}

  if (fs)
    XtCallActionProc (widget, "FullScreen", NULL, NULL, 0);

#ifdef USE_LIBXOSD
  xosd_destroy (osd_vtx);
  xosd_destroy (osd_main);
  xosd_destroy (osd_bar);  
  if (font)
      free(font);
  if (font_vtx)
      free(font_vtx);
  if (colour)
      free(colour);
#endif

  XtAppAddWorkProc (app_context, ExitWP, NULL);
  XtDestroyWidget (app_shell);
  close_socket();
}

/*--- Functions --------------------------------------------------*/

void sigpipe_handler(int sig) {
  fprintf(stderr, "received SIGPIPE\n");
}


void
sigint_handler(int sig)
{
  XKeyEvent kev;

  memset(&kev, 0, sizeof(XKeyEvent));
  kev.type = KeyPress;
  kev.send_event = True;
  kev.display = XtDisplay(tv);
  kev.window = XtWindow(tv);
  kev.keycode = XKeysymToKeycode(dpy, XK_Escape);
  printf("SIGINT received\n");

  XSendEvent(XtDisplay(tv), XtWindow(tv), True, 0, (XEvent *)&kev );
}

static void
lirc_input(XtPointer data, int *fd, XtInputId *iproc)
{
    if (debug)
	fprintf(stderr,"lirc_input triggered\n");
    if (-1 == lirc_tv_havedata()) {
	fprintf(stderr,"lirc: connection lost\n");
	XtRemoveInput(*iproc);
	close(*fd);
    }
}

/* ------------ screensaver management -----------------------------*/

static void
xscreensaver_timefunc(XtPointer clientData, XtIntervalId *id)
{
    static int first = 1;
    int status;
    char *err;

    if (debug)
	fprintf(stderr,"xscreensaver_timefunc\n");
    xscreensaver_timer = 0;
    if (first) {
	xscreensaver_init(dpy);
	first = 0;
    }
    status = xscreensaver_command(dpy,xa_deactivate,0,debug,&err);
    if (0 != status) {
	if (debug)
	    fprintf(stderr,"xscreensaver_command: %s\n",err);
	return;
    }
    xscreensaver_timer = XtAppAddTimeOut(app_context,30000, xscreensaver_timefunc,NULL);
}

static void
do_screensaver(int fs_state)
{
    static int timeout,interval,prefer_blanking,allow_exposures;
#ifdef HAVE_LIBXDPMS
    static BOOL dpms_on;
    CARD16 dpms_state;
    int dpms_dummy;
#endif

    if (fs_state) {
	/* fullscreen on -- disable screensaver */
	XGetScreenSaver(dpy,&timeout,&interval,
			&prefer_blanking,&allow_exposures);
	XSetScreenSaver(dpy,0,0,DefaultBlanking,DefaultExposures);
#ifdef HAVE_LIBXDPMS
	if ((DPMSQueryExtension(dpy, &dpms_dummy, &dpms_dummy)) &&
	    (DPMSCapable(dpy)))
	{
	  DPMSInfo(dpy, &dpms_state, &dpms_on);
          DPMSDisable(dpy);
	   if(debug) fprintf(stderr,"disable DPMS\n");
	}
#endif
	xscreensaver_timer = XtAppAddTimeOut(app_context,30000, xscreensaver_timefunc,NULL);
	   if(debug) fprintf(stderr,"disable screensaver\n");
    } else {
	/* fullscreen off -- enable screensaver */
	XSetScreenSaver(dpy,timeout,interval,prefer_blanking,allow_exposures);
#ifdef HAVE_LIBXDPMS
	if ((DPMSQueryExtension(dpy, &dpms_dummy, &dpms_dummy)) &&
	    (DPMSCapable(dpy)) && (dpms_on))
	{
	  DPMSEnable(dpy);
	   if(debug) fprintf(stderr,"enable DPMS\n");
	}
#endif
	if (xscreensaver_timer)
	    XtRemoveTimeOut(xscreensaver_timer);
	   if(debug) fprintf(stderr,"enable screensaver\n");
    }
}

/* ------------ END screensaver management --------------------------*/

/* ------------- onscreen display OSD ------------------------------*/

void
create_onscreen ()
{
#ifdef USE_LIBXOSD
  char *display;
  Display *screen_display;
  int screen;
#endif
  on_shell = XtVaCreateWidget ("onscreen", transientShellWidgetClass,
                               app_shell, XtNoverrideRedirect, True,
			       XtNvisual,vinfo->visual,
			       XtNcolormap,colormap,
			       XtNdepth,vinfo->depth, NULL);
  on_label = XtVaCreateManagedWidget ("label", labelWidgetClass, on_shell,
                                      NULL);
  vtx_shell = XtVaCreateWidget ("vtx", transientShellWidgetClass,
				app_shell, XtNoverrideRedirect, True,
				XtNvisual,vinfo->visual, XtNcolormap,colormap,
				XtNdepth,vinfo->depth, NULL);
  vtx_label = XtVaCreateManagedWidget ("label", labelWidgetClass, vtx_shell,
				       NULL);
#ifdef USE_LIBXOSD
  if (!font)
     font = strdup("-xxl-*-*-*-*-*-*-*-*-*-*-*-iso8859-1");
  if (!font_vtx)
     font_vtx = strdup("-adobe-courier-bold-*-*-*-14-*-*-*-*-*-iso8859-1");
  if (!colour)
     colour = strdup("green");
  osd_bar = xosd_create(3);     
  osd_main = xosd_create (1);
   if (!osd_main)
   {
      fprintf (stderr, "Error initializing osd: %s\n", xosd_error);
      libxosd_ok = 0;
      return;
   }

   if (xosd_set_font(osd_main, font))
       if (xosd_set_font(osd_main, osd_default_font))
       {
	  fprintf (stderr, "ABORT: %s\n", xosd_error);
	  libxosd_ok = 0;
	  return;
       }

   xosd_set_colour(osd_main, colour);

   osd_vtx = xosd_create (3);
   if (!osd_vtx)
   {
          fprintf (stderr, "Error initializing osd: %s\n", xosd_error);
	  libxosd_ok = 0;
	  return;
   }

   if (xosd_set_font(osd_vtx, font_vtx))
       if (xosd_set_font(osd_vtx, osd_default_font))
       {
	  fprintf (stderr, "ABORT: %s\n", xosd_error);
	  libxosd_ok = 0;
	  return;
       }

   xosd_set_colour(osd_vtx, colour);

   display = getenv ("DISPLAY");
   screen_display = XOpenDisplay (display);
   screen = XDefaultScreen (screen_display);
   screen_width = XDisplayWidth (screen_display, screen);
   screen_height = XDisplayHeight (screen_display, screen);
   XCloseDisplay (screen_display);
#endif
}

void
popdown_onscreen (XtPointer client_data, XtIntervalId * id)
{
  XtPopdown (on_shell);
  on_timer = 0;
}

void
#ifndef USE_LIBXOSD
osd (int x_osd, int y_osd, char *osd_msg, int osd_time)
#else
osd_xaw (int x_osd, int y_osd, char *osd_msg, int osd_time)
#endif
{
  /* if x_osd and y_osd > 0, the put osd window at x_osd and y_osd from top
   * left main window corner.
   * if x_osd < 0, center horizontaly osd window.
   * if y_osd < 0, y origin is the bottom of the main window...
   */
  static int first = 1;
  Dimension x, y;
  Dimension w, h;
  Dimension w_osd, h_osd;
  int vtx;

  Widget shell,label;

  vtx = (osd_time<0);  // DIRTY !!!!, should be a parameter
  if(vtx) {
    shell = vtx_shell; label = vtx_label;
  } else {
    shell = on_shell; label = on_label;
  }
  if(vtx) write_sub(osd_msg);
  if(vtx && *osd_msg == '\0') {
    XtPopdown (shell);
    return;
  }
  XtVaGetValues (app_shell, XtNx, &x, XtNy, &y, NULL);
  XtVaGetValues (app_shell, XtNwidth, &w, XtNheight, &h, NULL);

  XtVaSetValues (label, XtNlabel, osd_msg, NULL);
  XtVaGetValues (label, XtNwidth, &w_osd, XtNheight, &h_osd, NULL);

  if (x_osd > 0)
    x_osd += x;
  else
    x_osd = x + (w - w_osd)/2;

  if (y_osd > 0)
    y_osd += y;
  else
    y_osd = y + h - h_osd + y_osd;

  XtVaSetValues (shell, XtNx, x_osd, XtNy, y_osd, NULL);

  XtPopup (shell, XtGrabNone);

  if (vtx) return;

  if (on_timer)
    XtRemoveTimeOut (on_timer);

  if (osd_time > 0)
    on_timer = XtAppAddTimeOut
      (app_context, osd_time, popdown_onscreen, NULL);

  if (first)
    {
      first = 0;
      XDefineCursor (dpy, XtWindow (on_shell), no_ptr);
      XDefineCursor (dpy, XtWindow (on_label), no_ptr);
    }
}

#ifdef USE_LIBXOSD
#ifdef LIBXOSDPATCH
void osd_redraw(Dimension x, Dimension y, Dimension w, Dimension h)
{
  /*static time_t last_osd_redraw;
  time_t timeosd = time(NULL);
  if ( (timeosd - last_osd_redraw) > 1 )
  {
    xosd_set_display(osd_main,x,y,w,h);
    xosd_set_display(osd_vtx,x,y,w,h);
  }
  last_osd_redraw = timeosd;
*/}
#endif
void osd_xosd(int x_osd, int y_osd, char *osd_msg, int osd_time, int vtx)
{
  xosd *osd;
  Dimension x, y;
  Dimension w, h;

  XtVaGetValues (app_shell, XtNx, &x, XtNy, &y,
                XtNwidth, &w, XtNheight, &h, NULL);

  if (vtx)
    osd=osd_vtx;
  else
    osd=osd_main;

  if (x_osd > 0)
  {
#ifndef LIBXOSDPATCH
    x_osd += x;
#endif
    xosd_set_align(osd, XOSD_left);
  }
  else
  {
#ifndef LIBXOSDPATCH
    x_osd = x + w/2 - screen_width/2;
#else
    x_osd = 0;
#endif
    xosd_set_align(osd, XOSD_center);
  }

  if (y_osd > 0)
  {
#ifndef LIBXOSDPATCH
    y_osd += y;
#endif
    xosd_set_pos(osd, XOSD_top);
  }
  else
  {
#ifndef LIBXOSDPATCH
    y_osd = -(y + h - screen_height + y_osd );
#else
    y_osd = 0;
#endif
    xosd_set_pos(osd, XOSD_bottom);
  }

#ifdef LIBXOSDPATCH
  xosd_set_display(osd,x,y,w,h);
#endif

  if(vtx) write_sub(osd_msg);
  if(vtx && *osd_msg == '\0' && xosd_is_onscreen(osd)) {
    xosd_hide(osd);
    xosd_display (osd, 0, XOSD_string,"");
    xosd_display (osd, 1, XOSD_string,"");
    xosd_display (osd, 2, XOSD_string,"");
    return;
  }

 xosd_set_vertical_offset(osd, y_osd);
 xosd_set_horizontal_offset(osd, x_osd);
 if (!vtx)
 {
   xosd_set_timeout(osd, osd_time/1000);
   xosd_display (osd, 0, XOSD_string, osd_msg);
 }
 else
 {
   xosd_display (osd, 0, XOSD_string, strtok(osd_msg,"\n"));
   xosd_display (osd, 1, XOSD_string, strtok(NULL,"\n"));
   xosd_display (osd, 2, XOSD_string, strtok(NULL,"\n"));
 }
}

void osd(int x_osd, int y_osd, char *osd_msg, int osd_time)
{
  if (libxosd && libxosd_ok)
    osd_xosd(x_osd, y_osd, osd_msg, osd_time, osd_time<0);
  else
    osd_xaw(x_osd, y_osd, osd_msg, osd_time);
}
#endif

void
display_onscreen ()
{

  if (on_skip)
    {
      on_skip = 0;
      return;
    }

  if (!fs && de)
    return;

  osd(30, 20, title, ONSCREEN_TIME);

}

#ifdef USE_LIBXOSD
void
Show_bar(int color,int percent)
{

/*sound progress bar*/
Dimension x, y;
Dimension w, h;
char type_reg[20];
char value[20];
  XtVaGetValues (app_shell, XtNx, &x, XtNy, &y,
                XtNwidth, &w, XtNheight, &h, NULL);

  xosd_set_font (osd_bar, font);
  xosd_set_shadow_offset (osd_bar, 4);
  switch(color){

  	case 1 :
  		xosd_set_colour (osd_bar, "lawngreen"); // color for volume
   		sprintf(type_reg," Volume");
                sprintf (value, "%d%%", cur_volume);
		break;
	case 2 :
		xosd_set_colour (osd_bar, "white"); //color for bright
   		sprintf(type_reg," Brigth");
                sprintf (value, "%d%%", cur_bright*100/65536);
		break;
	case 3 :
		xosd_set_colour (osd_bar, "red"); //color for color
   		sprintf(type_reg," Color");
                sprintf (value, "%d%%", cur_color*100/65536);	
		break;
	case 4 :
		xosd_set_colour (osd_bar, "blue"); //color for hue
   		sprintf(type_reg," Hue");
                sprintf (value, "%d%%", cur_hue*100/65536);
		break;
	case 5 :
		xosd_set_colour (osd_bar, "yellow"); //color for contrast
   		sprintf(type_reg," Contrast");
                sprintf (value, "%d%%", cur_contrast*100/65536);
		break;
	default:
		xosd_set_colour (osd_bar, "lawngreen");
   		break;
	}
  xosd_set_pos (osd_bar, XOSD_bottom);
  xosd_set_vertical_offset (osd_bar, -y - h + screen_height);

  xosd_set_align (osd_bar, XOSD_center);
  xosd_set_horizontal_offset (osd_bar,x + w/2 - screen_width/2);

  xosd_set_bar_length(osd_bar, w/20);
  xosd_set_timeout(osd_bar, ONSCREEN_TIME/1000);
  xosd_display (osd_bar, 0,XOSD_string,type_reg);  
  xosd_display (osd_bar, 1, XOSD_percentage, percent);
  xosd_display (osd_bar, 2,XOSD_string,value);  

}

#endif

/* ------------- END onscreen display OSD ---------------------------*/

// -------------- TV Function ---------------------------------------*/

static Boolean
idle_grabdisplay1 (XtPointer data)
{
  static long count, lastsec;
  struct timeval tv;
  struct timezone tz;

  if (debug)
    {
      gettimeofday (&tv, &tz);
      if (tv.tv_sec != lastsec)
        {
          if (lastsec == tv.tv_sec - 1)
            {
              printf ("fps:%ld\n", count);
              fflush(stderr);
            }
          lastsec = tv.tv_sec;
          count = 0;
        }
      count++;
    }

  if ((NULL == grabbers[grabber]->grab_scr) ||
      (-1 == video_displayframe (grabbers[grabber]->grab_scr)))
    {
      idle_id = 0;
      usleep (300000);
      return TRUE;
    }
  return FALSE;
}

void
set_title ()
{
  if (-1 != cur_sender)
    {
      if (channels[cur_sender]->fine == 0)
        {
          if (cur_deinterlace == DEINTERLACE_NONE || disable_xv == 1)
            sprintf (title, "%s", channels[cur_sender]->name);
          else
            sprintf (title, "%s (%s)", channels[cur_sender]->name, int_to_str(cur_deinterlace, deinterlace_list));
        }
      else
        {
          sprintf (title, "channel %s", tvtuner[cur_channel].name);
          if (cur_fine != 0)
            sprintf (title + strlen (title), " (%d)", cur_fine);
          sprintf (title + strlen (title), " (%s/%s)",
                   grabbers[grabber]->norms[cur_norm].str,
                   chan_names[chan_tab].str);
        }
    }
  else
    sprintf(title, "No sender");

  if (is_divx_in_progress())
    sprintf(title, "%s RECORDING", title);

  XtVaSetValues (app_shell, XtNtitle, title, NULL);
  display_onscreen ();

  if (title_timer)
    {
      XtRemoveTimeOut (title_timer);
      title_timer = 0;
    }
}

void
set_property (int freq, char *channel, char *name)
{
  int len;
  char line[80];

  len = sprintf (line, "%.3f", (float) freq / 16) + 1;
  len += sprintf (line + len, "%s", channel) + 1;
  if (NULL != name)
    len += sprintf (line + len, "%s", name) + 1;
  XChangeProperty (dpy, XtWindow (app_shell),
                   xawtv_station, XA_STRING, 8, PropModeReplace, line, len);
}

void
set_title_timeout (XtPointer client_data, XtIntervalId * id)
{
  on_skip = 1;
  set_title ();
}

void
set_timer_title ()
{
  XtVaSetValues (app_shell, XtNtitle, title, NULL);
  display_onscreen ();
  if (title_timer)
    XtRemoveTimeOut (title_timer);
  title_timer = XtAppAddTimeOut
    (app_context, TITLE_TIME, set_title_timeout, NULL);
}


void
change_audio (int mode)
{
  if (grabbers[grabber]->grab_audio)
    grabbers[grabber]->grab_audio (-1, -1, &mode);
    //grabbers[grabber]->grab_audio (-1, -1, &mode); // double init needed for some of Nicam TV Cards: don't work!
    sprintf (title, "%-" LABEL_WIDTH "s : %s", "Audio", stereo[mode].str);
  if (c_audio)
    XtVaSetValues (c_audio, XtNlabel, title, NULL);
  set_title ();
  sprintf (title + strlen (title), " (%s)", stereo[mode].str);
  XtVaSetValues (app_shell, XtNtitle, title, NULL);
}


void
watch_audio (XtPointer data, XtIntervalId * id)
{
  on_skip = 1;
  change_audio (0);
  audio_timer = 0;
}

void
set_norm (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s : %s", "TV Norm",
           grabbers[grabber]->norms[j].str);
  if (c_norm)
    XtVaSetValues (c_norm, XtNlabel, title, NULL);
  cur_norm = j;
  grabbers[grabber]->grab_input (-1, cur_norm);
  if(grabbers[grabber]->is525(cur_norm)) {
    cur_maxwidth = 640;
    cur_maxheight = 480;
    cur_maxfpsnum = 30000;
    cur_maxfpsden = 1001;
  } else {
    cur_maxwidth = 768;
    cur_maxheight = 576;
    cur_maxfpsnum = 25;
    cur_maxfpsden = 1;
  }
  cur_secam = grabbers[grabber]->issecam(cur_norm);
  video_new_size (0);
}

void
set_source (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s : %s", "Video Source",
           grabbers[grabber]->inputs[j].str);
  if (c_input)
    XtVaSetValues (c_input, XtNlabel, title, NULL);
  cur_input = j;
  grabbers[grabber]->grab_input (cur_input, -1);
}

void
set_freqtab (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s : %s", "Frequency table",
           chan_names[j].str);
  if (c_freq)
    XtVaSetValues (c_freq, XtNlabel, title, NULL);
  chan_tab = j;
}

void
set_capture (int capture, int save)
{
/*  static int niced = 0; */

  if (cur_capture == capture)
    {
      if (cur_capture == CAPTURE_GRABDISPLAY && !idle_id)
        idle_id = XtAppAddWorkProc (app_context, idle_grabdisplay, NULL);
      return;
    }


  /* first turn off... */
  switch (cur_capture)
    {
    case CAPTURE_GRABDISPLAY:
      if (idle_id)
        XtRemoveWorkProc (idle_id);
      idle_id = 0;
      XClearArea (XtDisplay (tv), XtWindow (tv), 0, 0, 0, 0, True);
      break;

    case CAPTURE_OVERLAY:
      video_overlay (NULL);
      break;
    }

  cur_capture = capture;

  /* ... then turn on */
  switch (cur_capture)
    {
    case CAPTURE_OFF:
      sprintf (title, "%-" LABEL_WIDTH "s : %s", "Capture", "off");
      break;

    case CAPTURE_GRABDISPLAY:
      sprintf (title, "%-" LABEL_WIDTH "s : %s", "Capture", "grabdisplay");
      /*
      if (!niced)
        nice (niced = 10);
       */
      idle_id = XtAppAddWorkProc (app_context, idle_grabdisplay, NULL);
      break;

    case CAPTURE_OVERLAY:
      sprintf (title, "%-" LABEL_WIDTH "s : %s", "Capture", "overlay");

      video_overlay (grabbers[grabber]->grab_overlay);
      break;
    }

  video_new_size(ADAPT_SIZE);

  if (cur_sender != -1 && save)
    channels[cur_sender]->capture = cur_capture;

  if (c_cap)
    XtVaSetValues (c_cap, XtNlabel, title, NULL);
}

/* the RightWay[tm] to set float resources (copyed from Xaw specs) */
void
set_float (Widget widget, char *name, float value)
{
  Arg args[1];

  if (sizeof (float) > sizeof (XtArgVal))
    {
      /*
       * If a float is larger than an XtArgVal then pass this
       * resource value by reference.
       */
      XtSetArg (args[0], name, &value);
    }
  else
    {
      /*
       * Convince C not to perform an automatic conversion, which
       * would truncate 0.5 to 0.
       */
      XtArgVal *l_top = (XtArgVal *) & value;
      XtSetArg (args[0], name, *l_top);
    }
  XtSetValues (widget, args, 1);
}

void
set_picparams (int color, int bright, int hue, int contrast)
{
  char label [64];

  if (color != -1)
    {
      cur_color = color;
      if (s_color)
      {
        set_float (s_color, XtNtopOfThumb, (float) cur_color / 65536);
	if (debug)
	  fprintf (stderr, "color: %5d\n", cur_color);
	sprintf (label, "%-" LABEL_WIDTH2 "s:%3d%%", "Color", cur_color*100/65536);
        XtVaSetValues (l_color, XtNlabel, label, NULL);
      }
      if (cur_sender != -1)
        channels[cur_sender]->color = cur_color;
    }
  if (bright != -1)
    {
      cur_bright = bright;
      if (s_bright)
      {
        set_float (s_bright, XtNtopOfThumb, (float) cur_bright / 65536);
	if (debug)
	  fprintf (stderr, "bright: %3d\n", cur_bright);
	sprintf (label, "%-" LABEL_WIDTH2 "s:%3d%%", "Bright", cur_bright*100/65536);
        XtVaSetValues (l_bright, XtNlabel, label, NULL);
      }
      if (cur_sender != -1)
        channels[cur_sender]->bright = cur_bright;
    }
  if (hue != -1)
    {
      cur_hue = hue;
      if (s_hue)
      {
        set_float (s_hue, XtNtopOfThumb, (float) cur_hue / 65536);
	if (debug)
	  fprintf (stderr, "hue: %3d\n", cur_hue);
	sprintf (label, "%-" LABEL_WIDTH2 "s:%3d%%", "Hue", cur_hue*100/65536);
        XtVaSetValues (l_hue, XtNlabel, label, NULL);
      }
      if (cur_sender != -1)
        channels[cur_sender]->hue = cur_hue;
    }
  if (contrast != -1)
    {
      cur_contrast = contrast;
      if (s_contrast)
      {
        set_float (s_contrast, XtNtopOfThumb, (float) cur_contrast / 65536);
	if (debug)
	  fprintf (stderr, "contrast: %3d\n", cur_contrast);
	sprintf (label, "%-" LABEL_WIDTH2 "s:%3d%%", "Contrast", cur_contrast*100/65536);
        XtVaSetValues (l_contrast, XtNlabel, label, NULL);
      }
      if (cur_sender != -1)
        channels[cur_sender]->contrast = cur_contrast;
    }
  grabbers[grabber]->grab_picture (cur_color, cur_bright, cur_hue,
                                   cur_contrast);
}

void
set_deinterlace(int j)
{
  int len;
  int i;

  cur_deinterlace = j;
  if (cur_sender != -1)
    channels[cur_sender]->deinterlace = cur_deinterlace;

  if (disable_xv == 1)
    sprintf (title, "%-" LABEL_WIDTH "s : %s", "Deinterlace","None");
  else
    sprintf (title, "%-" LABEL_WIDTH "s : %s", "Deinterlace",
           int_to_str(j, deinterlace_list));

  len = strlen(title);

  for (i=len; i<=38-6; i++) // 6 = strlen("CTRL+D")
    title[i] = ' ';
  title[i] = 0;
  strcat(title, "Ctrl+D");

  if (c_deinterlace)
    XtVaSetValues (c_deinterlace, XtNlabel, title, NULL);

  title[len] = 0;
}

int
set_stayontop(int j)
{
  static int top = 0;
  char *fmt = NULL;

  if (!wm_stay_on_top)
    return 0;

  if (j == -1)
    top = 1 - top;
  else
    top = j;

	stay = top;
	if (debug)
	  fprintf(stderr, "Stay on Top State: %d\n", stay);
  switch(top)
    {
    case WMHOOKS_YES:
      fmt = "%-" LABEL_WIDTH "s :     (%s)     %6s";
      break;

    case WMHOOKS_NO:
      fmt = "%-" LABEL_WIDTH "s :      (%s)    %7s";
      break;
    }

  // if Yes/No, just transmit top value
  // if OnBottom/Normal/OnTop, transmit (top-1)
  wm_stay_on_top(dpy, XtWindow(app_shell), top);

  sprintf (title, fmt, "Stay on Top",
           int_to_str(top, yes_no_list), "T");

  if (c_stayontop)
    XtVaSetValues (c_stayontop, XtNlabel, title, NULL);

  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Stay on Top",
           int_to_str(top, yes_no_list));

#ifdef USE_LIBXOSD
	  xosd_hide(osd_main);
	  xosd_hide(osd_vtx);
#endif
  return 1;
}

int
set_decoration(int j)
{
  static int decoration = WMHOOKS_YES;
  char *fmt = NULL;

  if (j == -1)
    decoration = 1 - decoration;
  else
    decoration = j;

  wm_decoration(app_shell, decoration);

  switch(decoration)
    {
    case WMHOOKS_YES:
      fmt = "%-" LABEL_WIDTH "s:     (%s)      %5s";
      break;

    case WMHOOKS_NO:
      fmt = "%-" LABEL_WIDTH "s:      (%s)     %6s";
      break;
    }
  sprintf (title, fmt, "Window Decoration",
           int_to_str(decoration, yes_no_list), "B");

  if (c_decoration)
    XtVaSetValues (c_decoration, XtNlabel, title, NULL);

  title[0] = 0;

  de = decoration ;
  return 1;
}

int
set_subpageno(int j)
{
  char page_str[20], *subpageno_str;

  if (j == -1)
      subpageno = (subpageno+1)%(NB_SUBPAGENO);
  else if (j == -2)
      if(subpageno == 0) subpageno = NB_SUBPAGENO-1;
      else subpageno = (subpageno-1)%(NB_SUBPAGENO);
  else subpageno = j;

  subpageno_str = int_to_str(subpageno, subpageno_list);
  if(subpageno_str == NULL) return 0;

  if(subpageno_str == "Other")
  {
    sprintf (title,"Subtitles Page   :   (Other)    Shift+P");
    if (c_subpageno)
      XtVaSetValues (c_subpageno, XtNlabel, title, NULL);
    if (unactsubpage == 0)
      SubPageAction(NULL, NULL, NULL, NULL);
    return 0;
  }
  submethod = 0;
  unactsubpage = 0;
  subtitles_pageno_str = subpageno_str;
  sprintf(page_str,"(%-3s)",subpageno_str);
  if(subactive)
    set_subtitles_pageno(subpageno_str);
  sprintf (title,"%-" LABEL_WIDTH "s :%10s Alt/Ctrl+P",
	   "Subtitles Page",page_str);
  if (debug) {
    fprintf(stderr,"Subtitles Page Num.: %s\n",subtitles_pageno_str);
    fprintf(stderr,"Subactive: %d\n",subactive);
  }
  if (c_subpageno)
    XtVaSetValues (c_subpageno, XtNlabel, title, NULL);
  return 1;
}

int set_subactive(int j) {
  int subactive_prec = subactive;
  if(j == -1) {
    subactive = !subactive;
  }
  else subactive = j;
  if(subactive != subactive_prec) {
    if(subactive)
      set_subtitles_pageno(subtitles_pageno_str);
    else
      set_subtitles_pageno(NULL);
  }
  if(subactive)
  {
    sprintf (title,"%-" LABEL_WIDTH "s","Subtitles        :      (On)          P");
    if (c_togglesub)
    XtVaSetValues (c_togglesub, XtNlabel, title, NULL);
  }
  else
  {
    sprintf (title,"%-" LABEL_WIDTH "s","Subtitles        :     (Off)          P");
        if (c_togglesub)
    XtVaSetValues (c_togglesub, XtNlabel, title, NULL);
  }
  return 1;
}


void
record_movie(int j)
{
  char *fmt = NULL;
  Dimension w,h;
  int record, prev_record;

  record = is_divx_in_progress() ? RECORD_START : RECORD_STOP;
  prev_record = record;

  if (j == -1)
    {
      /* j = -1 means toggle state, but between RECORD_START
       * and RECORD_STOP only
       */
      record = record==RECORD_START ? RECORD_STOP : RECORD_START;
    }
  else
    {
      /* If record is in progress, do not allow to
       * raise RECORD_PARAM
       */
      if (record == RECORD_START && (j == RECORD_VIDEO_PARAM || j == RECORD_AUDIO_PARAM))
      {
	PopupMessage("The Video & Audio Recorder Options Windows\ncan't be reached during a record\n");
        return;
      }
      else
        record = j;
    }

  if (record == prev_record)
    return;

  switch(record)
    {
    case RECORD_START:
      XtVaGetValues (tv, XtNwidth, &w, XtNheight, &h, NULL);
      //video_get_size(&w, &h);
      divx_init(divx_pixmap_format, w, h);
      fmt = "%-" LABEL_WIDTH "s :      (On)          R";
      break;

    case RECORD_STOP:
      divx_stop();
      fmt = "%-" LABEL_WIDTH "s :     (Off)          R";
      break;

    case RECORD_VIDEO_PARAM:
      record = prev_record;
      fmt = "%-" LABEL_WIDTH "s : (Options)      Alt+R";
      DivXAction(NULL, NULL, NULL, NULL);
      //return; // return now: do not modify title
      break;

    case RECORD_AUDIO_PARAM:
      record = prev_record-1;
      fmt = "%-" LABEL_WIDTH "s : (Options)     Ctrl+R";
      DivXAudioAction(NULL, NULL, NULL, NULL);
      //return; // return now: do not modify title
      break;

    case STREAM_SERVER_PARAM:
      record = prev_record-1;
      fmt = "%-" LABEL_WIDTH "s : (Options)     Shift+R";
      StreamParamsAction(NULL, NULL, NULL, NULL);
      //return; // return now: do not modify title
      break;

    }

  sprintf (title, fmt, "Record movie");
  set_timer_title ();

  if (c_record)
    XtVaSetValues (c_record, XtNlabel, title, NULL);

    if (is_divx_in_progress())
      sprintf (title, "<<  Streaming Server Started..  >>");
    else
      sprintf (title, "<<  Streaming Server Stopped!!  >>");
  if (c_streaming && divx.stream)
    XtVaSetValues (c_streaming, XtNlabel, title, NULL);
}

void
select_alevt(int j)
{
#ifdef ALEVT_ENABLED

  char *fmt = NULL;

  if (j == -1)
    /* for xawdecode_command teletext */
    j = 0;

  // fabrication des arguments AleVT en provenance de la GUI

  if (alevt1st == 0)
  {
    strcpy (alevtarg,"");

    if (alevt_error_reduction != 0)
      strcat (alevtarg,"-noerc ");

    if (alevt_error_bell != 0)
      strcat (alevtarg,"-nobell ");

    switch(alevt_charset)
      {
      case 0:
	break;
      case 1:
        strcat (alevtarg,"-charset latin-2 ");
	break;
      case 2:
        strcat (alevtarg,"-charset koi8-r ");
	break;
      case 3:
        strcat (alevtarg,"-charset iso8859-7 ");
	break;
      }

    switch(alevt_finetune_mode)
    {
    case 0:
      break;
    case 1:
      strcat (alevtarg,"-finetune auto ");
      break;
    case 2:
        strcat (alevtarg,"-finetune ");
        strcat (alevtarg,alevt_finetune_str);
        strcat (alevtarg," ");
      break;
    }
    strcat (alevtarg,alevt_defaultpage_str);
  }

  switch(j)
    {
    case 0:
  	if (real_alevt_in_use == 1)
	{
	  fmt = "%-" LABEL_WIDTH "s :     (Off)     Ctrl+A";
	  stop_alevt();
	}
  	else
  	{
	  fmt = "%-" LABEL_WIDTH "s :      (On)     Ctrl+A";
    	  strcpy (alevtinit, "alevt ");
    	  strcat (alevtinit,alevtarg);
    	  start_alevt(alevtinit);
  	}
	break;
    case 1:
	fmt = "%-" LABEL_WIDTH "s : (Options)      Alt+A";
        AleVTParamsAction(NULL, NULL, NULL, NULL);
    	break;
    }

  fprintf(stderr,"alevt full command: %s\n",alevtinit);
  sprintf (title, fmt, "Teletext (AleVT)");
  set_timer_title ();

  if (c_alevt)
    XtVaSetValues (c_alevt, XtNlabel, title, NULL);

#endif
}

void
pixit (void)
{
  Pixmap pix;
  char *data;

  if (0 == pix_width || 0 == pix_height)
    return;

  if (cur_sender != -1 && grabbers[grabber]->grab_one)
    {
      strcpy (title, channels[cur_sender]->name);

      data = grabbers[grabber]->grab_one (x11_native_format, pix_width, pix_height);
      if (data != NULL)
        {
          pix = x11_create_pixmap (channels[cur_sender]->button, data,
                                   pix_width, pix_height, title);
          if (pix != 0)
            {
              if (channels[cur_sender]->pixmap)
                XFreePixmap (dpy, channels[cur_sender]->pixmap);
              channels[cur_sender]->pixmap = pix;
              XtVaSetValues (channels[cur_sender]->button,
                             XtNbackgroundPixmap, pix,
                             XtNlabel, "",
                             XtNwidth, pix_width, XtNheight, pix_height, NULL);
            }
        }
    }
}

void
set_channel (struct CHANNEL *channel)
{
  /* image parameters */
  set_picparams (channel->color, channel->bright,
                 channel->hue, channel->contrast);
  if(!is_divx_in_progress())
    set_capture (channel->capture, 1);

  if (plugin != NULL)
    plugin->set_channel(channel);

  /* input source */
  if (cur_input != channel->source)
    set_source (channel->source);
  if (cur_norm != channel->norm)
    set_norm (channel->norm);

  /* station */
  cur_channel = channel->channel;
  cur_fine = channel->fine;
  grabbers[grabber]->grab_tune (channel->freq);
  cur_freq = channel->freq;
  editor_station_switched ();
  //set_title ();
  set_property (channel->freq, channel->cname, channel->name);

  /* deinterlace */
  if (cur_deinterlace != channel->deinterlace)
    set_deinterlace (channel->deinterlace);

  set_title ();

  if(doublekey) {
    if (keypad_timer)
      {
	XtRemoveTimeOut (keypad_timer);
	keypad_timer = 0;
      }
    keypad_timer = XtAppAddTimeOut (app_context, KEYPAD_TIME, keypad_timeout, NULL);
  }

  if (zap_timer)
    {
      XtRemoveTimeOut (zap_timer);
      zap_timer = 0;
    }
  if (scan_timer)
    {
      XtRemoveTimeOut (scan_timer);
      scan_timer = 0;
    }
  if (audio_timer)
    {
      XtRemoveTimeOut (audio_timer);
      audio_timer = 0;
    }
  audio_timer = XtAppAddTimeOut (app_context, 10000, watch_audio, NULL);

#ifdef USE_LIBXOSD
xosd_hide(osd_bar);
#endif  
  
}

void
change_int (char *name, char *par, int *val)
{
  switch (par[0])
    {
    case '+':
    case '-':
      *val += atoi (par);
      break;
    default:
      *val = atoi (par);
      break;
    }
  if (*val < 0)
    *val = 0;
  if (*val > 65535)
    *val = 65535;
  sprintf (title, "%s: %d%%", name, *val * 100 / 65535);
}



void
set_volume ()
{
  int vol;
  char label[64];

  if (have_mixer)
    {
      vol = cur_volume;
      mixer_set_volume (vol);
      mixer_set_mute (cur_mute);
    }
  else
    {
      /* v4l */
      if (grabbers[grabber]->grab_audio)
		grabbers[grabber]->grab_audio (cur_mute, cur_volume * 65535 / 100 ,
				       NULL);
    }

  if (s_volume)
  {
    set_float (s_volume, XtNtopOfThumb, (float) cur_volume / 100);
    if (debug)
      fprintf (stderr, "volume: %3d\n", cur_volume);
    sprintf (label, "%-" LABEL_WIDTH2 "s:%3d%%", "Volume", cur_volume);
    XtVaSetValues (l_volume, XtNlabel, label, NULL);
  }
}

static void
keypad_timeout(XtPointer client_data, XtIntervalId *id)
{
    if (debug)
	fprintf(stderr, "keypad: timeout!!!\n");
    keypad_value = -1;
    keypad_timer = 0;
}



void
scan_timeout (XtPointer client_data, XtIntervalId * id)
{
  static String argv[] = { "next", NULL };

  scan_timer = 0;

  /* check */
  if (!grabbers[grabber]->grab_tuned)
    return;
  if (grabbers[grabber]->grab_tuned ())
    return;

  XtCallActionProc (tv, "Tune", NULL, argv, 1);
  scan_timer = XtAppAddTimeOut (app_context, SCAN_TIME, scan_timeout, NULL);
}

#ifdef HAVE_LIBXXF86VM
static void
vidmode_timer (XtPointer clientData, XtIntervalId * id)
{
  set_capture (CAPTURE_OVERLAY, 1);
}

static void
set_vidmode (int nr)
{
  if (CAPTURE_OVERLAY == cur_capture)
    video_overlay (NULL);
  usleep (VIDMODE_DELAY * 1000);
  if (debug)
    fprintf (stderr, "switching video mode to %dx%d now\n",
             vm_modelines[nr]->hdisplay, vm_modelines[nr]->vdisplay);
  XF86VidModeSwitchToMode (dpy, XDefaultScreen (dpy), vm_modelines[nr]);

  if (CAPTURE_OVERLAY == cur_capture)
    {
      cur_capture = 0;
      XtAppAddTimeOut (app_context, VIDMODE_DELAY, vidmode_timer, NULL);
    }
}
#endif

/* --- grab (single frames) to file ----------------------------------*/

void
select_snap (int jpeg, int size)
{
  void *buffer;
  char *filename = NULL;
  char *fmt = NULL;
  char *snapbase = "snap";
  char *name = NULL;
  Dimension width = cur_maxwidth;
  Dimension height = cur_maxheight;


// full size window
if (size == 1)
{
  width = cur_maxwidth;
  height = cur_maxheight;
}
// same size window
if (size == 0)
  XtVaGetValues (tv, XtNwidth, &width, XtNheight, &height, NULL);


  if (!grabbers[grabber]->grab_one)
    {
      fprintf (stderr, "grabbing: not supported\n");
      return;
    }

  strcpy (title, "grabbing...");
  set_timer_title ();

  if (NULL == (buffer = grabbers[grabber]->grab_one (-1, width, height)))
    {
      strcpy (title, "grabbing failed");
      set_timer_title ();
      return;
    }

  if (NULL == filename)
    {
      if (jpeg && (jpegfile != NULL))
	snapbase = jpegfile;
      else if (!jpeg && (ppmfile != NULL))
	snapbase = ppmfile;
      if (-1 != cur_sender)
        {
          name = channels[cur_sender]->name;
        }
      else
        {
          name = "???";
        }
      filename = snap_filename (snapbase, name, jpeg ? "jpeg" : "ppm");
    }

  if (jpeg)
    {
#ifdef HAVE_LIBJPEG
      write_jpeg (filename, buffer, width, height, 75, 0);
      sprintf (title, "saved jpeg: %s", filename);

      if (size == 0)
        fmt = "%-" LABEL_WIDTH "s :  (Saved!)     Ctrl+J";
      if (size == 1)
        fmt = "%-" LABEL_WIDTH "s :  (Saved!)          J";
#else
      sprintf (title, "no jpeg support, sorry");
#endif
    }
  else
    {
      write_ppm (filename, buffer, width, height);
      sprintf (title, "saved ppm: %s", filename);

      if (size == 0)
        fmt = "%-" LABEL_WIDTH "s :  (Saved!)     Ctrl+G";
      if (size == 1)
        fmt = "%-" LABEL_WIDTH "s :  (Saved!)          G";
    }

  set_timer_title ();

  sprintf (title, fmt, "Grab an Image");
  if (c_graball)
    XtVaSetValues (c_graball, XtNlabel, title, NULL);

}

void
button_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  struct CHANNEL *channel = clientdata;
  int i;

  if (is_divx_in_progress() && (!divx.chg))
    return;

  pixit ();
  for (i = 0; i < count; i++)
    if (channels[i] == channel)
      break;
  cur_sender = i;
  set_channel (channels[i]);
}

/* Xaw: Mozaic Channels -----------------------------------------*/

void
create_chanwin ()
{
  chan_shell = XtVaAppCreateShell ("Channels", "Xawdecode",
                                   topLevelShellWidgetClass,
                                   dpy, XtNclientLeader, app_shell,
				   XtNvisual,vinfo->visual,
				   XtNcolormap,colormap,
				   XtNdepth,vinfo->depth,NULL);
  chan_viewport = XtVaCreateManagedWidget ("viewport",
                                           viewportWidgetClass, chan_shell,
                                           XtNallowHoriz, False,
                                           XtNallowVert, True, NULL);
  chan_box = XtVaCreateManagedWidget ("channelbox",
                                      boxWidgetClass, chan_viewport,
                                      XtNsensitive, True, NULL);
}

/* Xaw: Stations -----------------------------------------*/

void channel_menu(void)
{
    int  i,max,len;
    char str[100];

    if (cmenu)
	free(cmenu);
    cmenu = malloc((count+1)*sizeof(struct STRTAB));
    memset(cmenu,0,(count+1)*sizeof(struct STRTAB));
    for (i = 0, max = 0; i < count; i++) {
	len = strlen(channels[i]->name);
	if (max < len)
	    max = len;
    }
    for (i = 0; i < count; i++) {
	cmenu[i].nr      = i+1;
	cmenu[i].str     = channels[i]->name;
	if (channels[i]->key) {
	    sprintf(str,"%2d  %-*s  %s",i+1,
		    max+2,channels[i]->name,channels[i]->key);
	} else {
	    sprintf(str,"%2d  %-*s",i+1,max+2,channels[i]->name);
	}
	cmenu[i].str=strdup(str);
    }
    editor_list_update ();
}

//--- channel hopping ---------------------------------------

void
zap_timeout (XtPointer client_data, XtIntervalId * id)
{
  static int muted = 0;
  char *fmt = NULL;

  if (zap_fast && !cur_mute)
    {
      /* mute for fast channel scan */
      muted = cur_mute = 1;
      set_volume ();
    }
  pixit ();
  cur_sender = (cur_sender + 1) % count;
  set_channel (channels[cur_sender]);
  if (cur_sender != zap_start)
    {
      sprintf (title, "Channel Hopping On: %s", channels[cur_sender]->name);
      XtVaSetValues (app_shell, XtNtitle, title, NULL);
      display_onscreen ();
      zap_timer = XtAppAddTimeOut
        (app_context, zap_fast ? CAP_TIME : ZAP_TIME, zap_timeout, NULL);
    }
  else
    {
      if (muted)
        {
          muted = cur_mute = 0;
          set_volume ();
        }
      fmt = "%-" LABEL_WIDTH "s :     (Off)   Ctrl+Z/Z";
      sprintf (title, fmt, "Channel Hopping");
      if (c_zap)
        XtVaSetValues (c_zap, XtNlabel, title, NULL);
    }
}

void
select_zap(int j)
{

  char *fmt = NULL;

  if (zap_timer)
  {
    XtRemoveTimeOut (zap_timer);
    zap_timer = 0;
    fmt = "%-" LABEL_WIDTH "s :     (Off)   Ctrl+Z/Z";
    strcpy (title, "channel hopping off");
    set_timer_title ();
  }
  else
  {
    zap_start = (cur_sender == -1) ? 0 : cur_sender;

    switch(j)
    {
      case 0:
        zap_fast = 0;
        fmt = "%-" LABEL_WIDTH "s :    (Slow)          Z";
	break;

      case 1:
        zap_fast = 1;
        fmt = "%-" LABEL_WIDTH "s :    (Fast)     Ctrl+Z";
	break;
    }

    if (count)
      zap_timer = XtAppAddTimeOut
    (app_context, CAP_TIME, zap_timeout, NULL);
  }

  sprintf (title, fmt, "Channel Hopping");
  if (c_zap)
    XtVaSetValues (c_zap, XtNlabel, title, NULL);

}

/*---------------------- END Functions --------------------------------------*/

/* -------------------- ACTION function -------------------------------------*/

void
SetBlackborderAction (Widget widget, XEvent * event,
                String * params, Cardinal * num_params)
{
      if (*num_params > 0)
        {
          if (0 == strcasecmp (params[0], "inc"))
            set_blackborder(0);
          else if (0 == strcasecmp (params[0], "dec"))
            set_blackborder(1);
          else
            return;
        }
}

void
SetChannelAction (Widget widget, XEvent * event,
                  String * params, Cardinal * num_params)
{
  int i;

  if (*num_params > 1)
    return;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress() && (!divx.chg))
    return;
#endif

  if(!count) return; // no channels configured !

  if (0 == strcmp (params[0], "next"))
    {
      i = (cur_sender + 1) % count;
    }
  else if (0 == strcmp (params[0], "prev"))
    {
      i = (cur_sender + count - 1) % count;
    }
  else
    {
      /* search the configured channels first... */
      for (i = 0; i < count; i++)
        if (0 == strcasecmp (channels[i]->name, params[0]))
          break;
      /* ... if it failes, take the argument as index */
      if (i == count)
        i = atoi (params[0]);
      if(doublekey) {
	int old_keypad_value=keypad_value;
	if(i>=0 && i<=9) {
	  if(keypad_value!=-1) {
	    int j;
	    if(doublekey_firstisone && i==9)
	      j = -1 + keypad_value*10;
	    else
	      j = i + keypad_value*10;
	    if(j<count) i=j;
	  }
	  keypad_value = i;
	  if(doublekey_firstisone) {
	    keypad_value++;
	    if(old_keypad_value==-1 && keypad_value==10)
	      keypad_value=-1;
	  }
	} else
	  keypad_value = -1;
      }
    }
  if (i >= 0 && i < count)
    {
      if (!cur_mute) mixer_set_mute(1);
      pixit ();
      cur_sender = i;
      set_channel (channels[i]);
      usleep(MUTE_TIME * 1000);
      if (!cur_mute) mixer_set_mute(0);
    }
  osd(-1, -1, "", -1);
}


void
SetSourceAction (Widget widget, XEvent * event,
                  String * params, Cardinal * num_params)
{
  int i=0;


  if (*num_params > 1)
    return;

  if (debug)
    fprintf(stderr, "cur_input: %d\n", cur_input);

  if (count && 0 == strcmp (params[0], "next"))
    {
      i = (cur_input + 1) % count;
      if (NULL == grabbers[grabber]->inputs[i].str)
	cur_input = i = 0;
    }
  else if (count && 0 == strcmp (params[0], "prev"))
    {
	if (cur_input>0)
    	    i = (cur_input + count - 1) % count;
	else
	{
	    while (NULL != grabbers[grabber]->inputs[++i].str);
	    i--;
	}
    }
  if (i >= 0 && i < count)
    set_source(i);
}


/* used by nxtvepg, do not remove !! */
void
RemoteAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  Atom type;
  int format, argc, i;
  char *argv[32];
  unsigned long nitems, bytesafter;
  unsigned char *args = NULL;

  if (event->type == PropertyNotify)
    {
#if 0
      fprintf (stderr, "PropertyNotify %s\n",
               XGetAtomName (dpy, event->xproperty.atom));
#endif
      if (event->xproperty.atom == xawtv_remote &&
          Success == XGetWindowProperty (dpy,
                                         event->xproperty.window,
                                         event->xproperty.atom,
                                         0, (65536 / sizeof (long)),
                                         True, XA_STRING,
                                         &type, &format, &nitems, &bytesafter,
                                         &args) && nitems != 0)
        {
          if (debug)
            fprintf (stderr, "remote control: ");

          for (i = 0, argc = 0; i < nitems; i += strlen (args + i) + 1)
            {
              if (debug)
                fprintf (stderr, "'%s' ", args + i);

              argv[argc++] = args + i;
            }

          if (debug)
            fprintf (stderr, "\n");

          if (0 == strcasecmp (argv[0], "setstation") && argc > 1)
            {
              XtCallActionProc (tv, "SetChannel", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "setchannel") && argc > 1)
            {
              XtCallActionProc (tv, "Tune", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "volume") && argc > 1)
            {
              XtCallActionProc (tv, "Volume", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "resmode") && argc > 1)
            {
              res_mode = (res_mode + 1) % 3;
            }
          else if (0 == strcasecmp (argv[0], "resource") && argc > 1)
            {
              char *newarg[2];
              newarg[0] = res_modes[res_mode];
              argv[1] = argv[1];
              XtCallActionProc (tv, "SetRes", NULL, newarg, 2);
            }
          else if (0 == strcasecmp (argv[0], "message") && argc > 1)
            {
	      /* used by nxtvepg do not remove !!!*/
              strcpy (title, argv[1]);
              set_timer_title ();
            }
          else if (0 == strcasecmp (argv[0], "vtx"))
            {
              if (argc == 1)
                {
                  // single vtx command with no args -> clear osd
                  popdown_onscreen (NULL, NULL);
                }
              else if (argc > 1)
                {
                  // n line vtx command
                  char *s;
                  int size;

                  size=1;
                  for(i=1; i<argc; i++)
                    size += strlen(argv[i])+1;
                  s = malloc(size);
                  *s=0;
                  for(i=1; i<argc-1; i++)
                    sprintf(s, "%s%s\n", s, argv[i]);
                  sprintf(s, "%s%s", s, argv[argc-1]);
                  osd(-1, -1, s, -1);

                  free(s);
                }
            }

          XFree (args);
        }
    }
}


void
ScanAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  static String argv[] = { "next", NULL };

  pixit ();
  XtCallActionProc (tv, "Tune", NULL, argv, 1);
  scan_timer = XtAppAddTimeOut (app_context, SCAN_TIME, scan_timeout, NULL);
}

void
TuneAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  int c, freq;

  if (*num_params < 1)
    return;

  if (is_divx_in_progress() && (!divx.chg))
    return;

  if (0 == strcasecmp (params[0], "next"))
    {
      do
        {
          cur_channel = (cur_channel + 1) % CHAN_ENTRIES;
        }
      while (!tvtuner[cur_channel].freq[chan_tab]);
      cur_fine = defaults.fine;
      cur_sender = -1;
    }
  else if (0 == strcasecmp (params[0], "prev"))
    {
      do
        {
          cur_channel = (cur_channel + CHAN_ENTRIES - 1) % CHAN_ENTRIES;
        }
      while (!tvtuner[cur_channel].freq[chan_tab]);
      cur_fine = defaults.fine;
      cur_sender = -1;
    }
  else if (0 == strcasecmp (params[0], "fine_up"))
    {
      cur_fine++;
      if (cur_sender != -1)
        channels[cur_sender]->fine = cur_fine;
    }
  else if (0 == strcasecmp (params[0], "fine_down"))
    {
      cur_fine--;
      if (cur_sender != -1)
        channels[cur_sender]->fine = cur_fine;
    }
  else
    {
      if (-1 != (c = lookup_channel (params[0])))
        {
          cur_channel = c;
          cur_fine = defaults.fine;
        }
      cur_sender = -1;
    }

  pixit ();

  // Why the hell were those 2 lines here ?
  //cur_sender = -1;
  //set_capture (defaults.capture /* CAPTURE_OVERLAY */ );

  freq = get_freq (cur_channel) + cur_fine;

  if (cur_sender != -1)
    channels[cur_sender]->freq = freq;

  grabbers[grabber]->grab_tune (freq);
  cur_freq = freq;
  editor_station_switched ();
  set_title ();
  set_property (freq, tvtuner[cur_channel].name, NULL);

  if (zap_timer)
    {
      XtRemoveTimeOut (zap_timer);
      zap_timer = 0;
    }
  if (scan_timer)
    {
      XtRemoveTimeOut (scan_timer);
      scan_timer = 0;
    }
  if (audio_timer)
    {
      XtRemoveTimeOut (audio_timer);
      audio_timer = 0;
    }
  audio_timer = XtAppAddTimeOut (app_context, 10000, watch_audio, NULL);
}

void
ChannelAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  int i;

  if (is_divx_in_progress() && (!divx.chg))
    return;

  if (0 == count)
    return;
  i = popup_menu (widget, "Stations", cmenu);

  if (i != -1)
    {
      if (!cur_mute) mixer_set_mute(1);
      pixit ();
      cur_sender = i - 1;
      set_channel (channels[cur_sender]);
      usleep(MUTE_TIME * 1000);
      if (!cur_mute) mixer_set_mute(0);
    }
}

void
PointerAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  pointer_on = !pointer_on;
  XDefineCursor (dpy, XtWindow (tv), pointer_on ? left_ptr : no_ptr);
}

Boolean
MyResize (XtPointer client_data)
{
  video_new_size (ADAPT_SIZE);

  return TRUE;
}

void
CloseMainAction (Widget widget, XEvent * event,
                 String * params, Cardinal * num_params)
{
  static Dimension x, y, w, h;
  char *argv[32];
  int argc = 0;

  if (event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Main: wm_save_yourself\n");

          argv[argc++] = progname;

          /* position */
          if (fs)
            {
              argv[argc++] = strdup ("-f");
            }
          else
            {
              XtVaGetValues (app_shell,
                             XtNx, &x, XtNy, &y, XtNwidth, &w, XtNheight, &h,
                             NULL);
              argv[argc++] = strdup ("-geometry");
              sprintf (argv[argc++] = malloc (32), "%dx%d+%d+%d", w, h, x, y);
            }
          argv[argc++] = strdup ("-c");
          argv[argc++] = strdup (device.video);

          /* grab filename */
          if (ppmfile)
            {
              argv[argc++] = strdup ("-o");
              argv[argc++] = malloc (256);
              argv[argc - 1][0] = '\0';
              if (ppmfile[0] != '/')
                {
                  getcwd (argv[argc - 1], 128);
                  strcat (argv[argc - 1], "/");
                }
              strcat (argv[argc - 1], ppmfile);
            }
          if (jpegfile)
            {
              argv[argc++] = strdup ("-j");
              argv[argc++] = malloc (256);
              argv[argc - 1][0] = '\0';
              if (jpegfile[0] != '/')
                {
                  getcwd (argv[argc - 1], 128);
                  strcat (argv[argc - 1], "/");
                }
              strcat (argv[argc - 1], jpegfile);
            }

          /* options */
          if (!xfree_ext)
            argv[argc++] = strdup ("-x");
          if (!pointer_on)
            argv[argc++] = strdup ("-m");
          if (bpp)
            {
              argv[argc++] = strdup ("-b");
              sprintf (argv[argc++] = malloc (8), "%d", bpp);
            }

          /* channel */
	  if (cur_sender!=-1)
          argv[argc++] = channels[cur_sender]->name;

          XSetCommand (XtDisplay (app_shell), XtWindow (app_shell), argv,
                       argc);
          return;
        }
    }
  ExitCB (widget, NULL, NULL);
}

void
FullScreenAction (Widget widget, XEvent * event,
                  String * params, Cardinal * num_params)
{
  static Dimension x, y, w, h;
  static int rpx, rpy, mouse;
#ifdef HAVE_LIBXXF86VM
  static int vm_switched;
#endif

  Window root, child;
  int wpx, wpy, mask;
#ifdef USE_LIBXOSD
xosd_hide(osd_bar);
#endif  

  if (fs)
    {
      if (wm_fullscreen != NULL)
        {
          wm_fullscreen(dpy, XtWindow(app_shell), 0);
	  do_screensaver(0);
	  //fprintf(stderr,"boucle 1: tirement de l'image\n");
        }
      else
        {

#ifdef HAVE_LIBXXF86VM
          if (have_vm && vm_switched)
            {
              set_vidmode (0);
              vm_switched = 0;
            }
#endif

          if (on_timer)
            {
              XtPopdown (on_shell);
              XtRemoveTimeOut (on_timer);
              on_timer = 0;
            }


          XtVaSetValues (app_shell,
                         XtNwidthInc, WIDTH_INC,
                         XtNheightInc, HEIGHT_INC,
                         XtNx, x + fs_xoff,
                         XtNy, y + fs_yoff, XtNwidth, w, XtNheight, h, NULL);

	  do_screensaver(0);
	  //fprintf(stderr,"boucle 2: avec switch de rsolution\n");

        }
      XWarpPointer (dpy, None, RootWindowOfScreen (XtScreen (tv)),
                    0, 0, 0, 0, rpx, rpy);

      if (staytmp == 0)
      set_stayontop(WMHOOKS_NO);

      fs = 0;
    }
  else
    {
      int vp_x, vp_y, vp_width, vp_height;

      if (wm_fullscreen != NULL)
        {
          wm_fullscreen(dpy, XtWindow(app_shell), 1);
	  do_screensaver(1);
	  //fprintf(stderr,"boucle 1: tirement de l'image\n");
	  //xscreensaver_timer = XtAppAddTimeOut(app_context,60000, xscreensaver_timefunc,NULL);
        }
      else
        {

	  vp_x = 0;
          vp_y = 0;
          vp_width = swidth;
          vp_height = sheight;
          XQueryPointer (dpy, RootWindowOfScreen (XtScreen (tv)),
                         &root, &child, &rpx, &rpy, &wpx, &wpy, &mask);

#ifdef HAVE_LIBXXF86VM
          if (have_vm)
            {
              int i;
              XF86VidModeGetAllModeLines (dpy, XDefaultScreen (dpy),
                                          &vm_count, &vm_modelines);
              for (i = 0; i < vm_count; i++)
                if (fs_width == vm_modelines[i]->hdisplay &&
                    fs_height == vm_modelines[i]->vdisplay)
                  break;
              if (i != 0 && i != vm_count)
                {
                  set_vidmode (i);
                  vm_switched = 1;
                  vp_width = vm_modelines[i]->hdisplay;
                  vp_height = vm_modelines[i]->vdisplay;
                }
              else
                {
                  vm_switched = 0;
                  vp_width = vm_modelines[0]->hdisplay;
                  vp_height = vm_modelines[0]->vdisplay;
                }

              XWarpPointer (dpy, None, RootWindowOfScreen (XtScreen (tv)),
                            0, 0, 0, 0, vp_width / 2, vp_height / 2);
              XF86VidModeSetViewPort(dpy,XDefaultScreen(dpy),
                    fs_xoff<0?-fs_xoff:0,
                    fs_yoff<0?-fs_yoff:0);

	    }
#endif

          XtVaGetValues (app_shell,
                         XtNx, &x, XtNy, &y, XtNwidth, &w, XtNheight, &h, NULL);

#ifdef HAVE_LIBXINERAMA
	if (nxinerama) {
	    /* check which physical screen we are visible on */
	    int i;
	    for (i = 0; i < nxinerama; i++) {
		if (x >= xinerama[i].x_org &&
		    y >= xinerama[i].y_org &&
		    x <  xinerama[i].x_org + xinerama[i].width &&
		    y <  xinerama[i].y_org + xinerama[i].height) {
		    vp_x      = xinerama[i].x_org;
		    vp_y      = xinerama[i].y_org;
		    vp_width  = xinerama[i].width;
		    vp_height = xinerama[i].height;
		    break;
		}
	    }
	}
#endif
	if (debug)
	    fprintf(stderr,"viewport: %dx%d+%d+%d\n",
		    vp_width,vp_height,vp_x,vp_y);

          XtVaSetValues (app_shell, XtNwidthInc, 1, XtNheightInc, 1, NULL);
          XtVaSetValues (app_shell,
                         XtNx, (vp_x & 0xfffc) + (fs_xoff<0?0:fs_xoff),
                         XtNy, vp_y + (fs_yoff<0?0:fs_yoff),
                         XtNwidth, vp_width, XtNheight, vp_height, NULL);

          XRaiseWindow (dpy, XtWindow (app_shell));

	  do_screensaver(1);
	  //fprintf(stderr,"boucle 2: avec switch de rsolution\n");
          //xscreensaver_timer = XtAppAddTimeOut(app_context,60000, xscreensaver_timefunc,NULL);
        }
      XWarpPointer (dpy, None, XtWindow (tv), 0, 0, 0, 0, 30, 15);
      mouse = pointer_on;

      staytmp = stay;
      if (stay == 0)
      set_stayontop(WMHOOKS_YES);

      fs = 1;
    }
  if (mouse)
    XtCallActionProc (tv, "Pointer", NULL, NULL, 0);
  XtAppAddWorkProc (app_context, MyResize, NULL);
}


void
ZapAction (Widget widget, XEvent * event,
           String * params, Cardinal * num_params)
{
  if (*num_params > 0)
  {
      if (0 == strcasecmp (params[0], "fast"))
        select_zap(1);
  }
  else
  {
    select_zap(0);
  }
}

void
ChannelsAction (Widget widget, XEvent * event,
                String * params, Cardinal * num_params)
{
  static int mapped = 0, first = 1;
  Dimension height, width;
  Position x = 0, y = 0;

  if (!count)
    return;

  if (event && event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Channels: wm_save_yourself\n");
          XSetCommand (XtDisplay (chan_shell), XtWindow (chan_shell), NULL, 0);
          return;
        }
    }

  if (mapped)
    {
      XtPopdown (chan_shell);
      mapped = 0;
    }
  else
    {
      mapped = 1;
      select_zap(1);
      if (first)
        {
          XtVaGetValues (chan_shell, XtNheight, &height, NULL);
          XtVaGetValues (chan_shell, XtNwidth, &width, NULL);

	  if (count < 4)
	  {
            XtVaSetValues (chan_shell, XtNheight, pix_height+10, NULL);
	    if (count == 1)
              XtVaSetValues (chan_shell, XtNwidth, pix_width+25, NULL);
	    else if (count == 2)
              XtVaSetValues (chan_shell, XtNwidth, pix_width*2+25, NULL);
	    else if (count == 3)
              XtVaSetValues (chan_shell, XtNwidth, pix_width*3+25, NULL);
	  }
	  else if (count > 3 && count < 7)
	  {
	    XtVaSetValues (chan_shell, XtNheight, pix_height*2+10, NULL);
            XtVaSetValues (chan_shell, XtNwidth, pix_width*3+25, NULL);
	  }
	  else if (count > 6)
	  {
            XtVaSetValues (chan_shell, XtNheight, pix_height*3+10, NULL);
            XtVaSetValues (chan_shell, XtNwidth, pix_width*3+25, NULL);
	  }
	  XtVaSetValues(chan_shell, XtNx, x, XtNy, y,NULL); // pour que la fenetre soit en haut  gauche de l'cran
        }
      XtPopup (chan_shell, XtGrabNone);
      if(first) {
	XSetWMProtocols (XtDisplay (chan_shell), XtWindow (chan_shell), wm_protocols, 2);
	first=0;
      }
    }
}


void
RecordMovieAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  record_movie(-1);
}

void
SubtitlesPagenoAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  unactsubpage = 1;
  set_subpageno(-1);
  set_timer_title ();
}

void
UnSubtitlesPagenoAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  unactsubpage = 1;
  set_subpageno(-2);
  set_timer_title ();
}

void
ToggleSubAction (Widget widget, XEvent * event,
		 String * params, Cardinal * num_params)
{
  set_subactive(-1);
  set_timer_title ();
}

void
DeinterlaceAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  set_deinterlace( (cur_deinterlace + 1) % NB_DEINTERLACE );
  set_timer_title ();
}

void
StayOnTopAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  if (set_stayontop(-1))
    set_timer_title ();
}

void
DecorationAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
   if (on_timer)
   {
     XtPopdown (on_shell);
     XtRemoveTimeOut (on_timer);
     on_timer = 0;
   }
  set_decoration(-1);
}

void
VolumeAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  char *msg = (char *)NULL;

  if (*num_params < 1)
    return;

  if (0 == strcasecmp (params[0], "mute") ||
      0 == strcasecmp (params[0], "tvmute"))
    cur_mute = !cur_mute;
  else if (0 == strcasecmp (params[0], "inc"))
    {
      if(!cur_mute)
	cur_volume += 1;
    }
  else if (0 == strcasecmp (params[0], "dec"))
    {
      if(!cur_mute)
	cur_volume -= 1;
    }
  else
    cur_volume += atoi (params[0]);

  if (cur_volume < 0)
    cur_volume = 0;
  if (cur_volume > 100)
    cur_volume = 100;

  if (plugin != NULL)
    msg = plugin->use_alternate();

  set_volume ();

  if (cur_mute)
    sprintf (title, "Volume (%s): muted", have_mixer ? "mixer" : "v4l");
  else
    sprintf (title, "Volume (%s): %d%%", have_mixer ? "mixer" : "v4l",
             cur_volume);

   if (0 == strcasecmp (params[0], "tvmute")&&
       grabbers[grabber]->grab_audio) {
     grabbers[grabber]->grab_audio (cur_mute, -1, NULL);
     strcat(title, " + TVMUTE");
   }

  if (msg)
    sprintf (title, "%s %s", title, msg);

  #ifdef USE_LIBXOSD
  if (libxosd && !cur_mute)
    Show_bar(1,cur_volume);
  else
  #endif    
    set_timer_title ();
}

void
SetBgAction (Widget widget, XEvent * event,
             String * params, Cardinal * num_params)
{
  XColor have, exact;

  if (*num_params != 1)
    fprintf (stderr, "SetBg: usage: SetRes(color)\n");
  XAllocNamedColor (dpy, DefaultColormapOfScreen (XtScreen (widget)),
                    params[0], &have, &exact);
  XtVaSetValues (widget, XtNbackground, have.pixel, NULL);
}

void
SetShadowAction (Widget widget, XEvent * event,
                 String * params, Cardinal * num_params)
{
  Dimension n;

  if (*num_params != 1)
    fprintf (stderr, "SetShadow: usage: SetShadow(int)\n");
  n = atoi (params[0]);
  XtVaSetValues (widget, "shadowWidth", n, NULL);
}

void
ShowtimeAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
    struct tm *times;
    time_t timet;

    timet = time(NULL);
    times = localtime(&timet);
    strftime(title, 6, "%k:%M", times);
    set_timer_title ();
}

#ifdef USE_LIBXOSD
void
XosdAction(Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
    libxosd=!libxosd;
    if (libxosd)
     {
    	sprintf (title,"%-" LABEL_WIDTH "s","Xosd             :      (On)     Ctrl+X");
    if (c_xosdaction)
    XtVaSetValues (c_xosdaction, XtNlabel, title, NULL);


     }
    else
     {
    	sprintf (title,"%-" LABEL_WIDTH "s","Xosd             :     (Off)     Ctrl+X");
        if (c_xosdaction)
    	XtVaSetValues (c_xosdaction, XtNlabel, title, NULL);

    }
  xosd_hide(osd_main);
  xosd_hide(osd_vtx);
  XtPopdown (on_shell);
  XtPopdown (vtx_shell);

  set_timer_title ();

}
#endif

void
SetResAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  if (*num_params != 2)
    fprintf (stderr, "SetRes: usage: SetRes(resource,value)\n");

  if (0 == strcmp ("color", params[0]))
    {
      change_int (params[0], params[1], &cur_color);
      set_picparams (cur_color, -1, -1, -1);
      #ifdef USE_LIBXOSD
      if (libxosd)
        Show_bar(3,cur_color*100/65536);
      #endif      
    }
  else if (0 == strcmp ("contrast", params[0]))
    {
      change_int (params[0], params[1], &cur_contrast);
      set_picparams (-1, -1, -1, cur_contrast);
      #ifdef USE_LIBXOSD
      if (libxosd)
        Show_bar(5,cur_contrast*100/65536);
      #endif      
    }
  else if (0 == strcmp ("bright", params[0]))
    {
      change_int (params[0], params[1], &cur_bright);
      set_picparams (-1, cur_bright, -1, -1);
      #ifdef USE_LIBXOSD
      if (libxosd)
        Show_bar(2,cur_bright*100/65536);
      #endif      
    }
  else if (0 == strcmp ("hue", params[0]))
    {
      change_int (params[0], params[1], &cur_hue);
      set_picparams (-1, -1, cur_hue, -1);
      #ifdef USE_LIBXOSD
      if (libxosd)      
        Show_bar(4,cur_hue*100/65536);
      #endif      
    }
  else if (0 == strcmp (params[0], "capture"))
    {
      if(!is_divx_in_progress())
	set_capture ((cur_capture + 1) % 3, 1);
    }
  else if (0 == strcmp ("audio", params[0]))
    {
      change_audio (atoi (params[1]));
    }
  else
    return;
#ifdef USE_LIBXOSD
  if (!libxosd) 
#endif
    set_timer_title ();
  return;
}

void
SnapAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  int jpeg = 0; // jpeg | ppn
  int size = 0; // full | win

    if (debug)
      fprintf(stderr,"argument numbers = %d\n",*num_params);

  if (*num_params > 0)
    {
      if (0 == strcasecmp (params[0], "jpeg"))
        jpeg = 1;
      if (0 == strcasecmp (params[0], "ppm"))
        jpeg = 0;
    }

  if (*num_params > 1)
    {
      if (0 == strcasecmp (params[1], "full"))
        size = 1;
      if (0 == strcasecmp (params[1], "win"))
        size = 0;
    }
    if (debug)
      fprintf(stderr,"jpeg = %d , size = %d\n", jpeg, size);
    select_snap(jpeg,size);
}

void
AleVTAction (Widget widget, XEvent * event,
             String * params, Cardinal * num_params)
{
select_alevt(-1);
}


/* --- Xaw: Main Options GUI -------------------------------------- */
/* --- Xaw: Main Options GUI -------------------------------------- */
/* --- Xaw: Main Options GUI -------------------------------------- */

struct CALL_ACTION call_chan = { 0, "Channels", {NULL} };
struct CALL_ACTION call_editor = { 0, "Editor", {NULL} };
struct CALL_ACTION call_xfreeparams = { 0, "XFreeParams", {NULL} };
struct CALL_ACTION call_cap = { 2, "SetRes", {"capture", "toggle", NULL} };
struct CALL_ACTION call_togglesub = { 0, "ToggleSub", {NULL} };
struct CALL_ACTION call_help = { 0, "Help", {NULL} };
#ifdef USE_LIBXOSD
struct CALL_ACTION call_xosdaction = { 0, "Xosd", {NULL} };
#endif

void
action_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  struct CALL_ACTION *ca = clientdata;

  XtCallActionProc (widget, ca->name, NULL, ca->argv, ca->argc);
}

void
menu_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  int cd = (int) clientdata;
  int j;
  int notitle = 0;

  switch (cd)
    {
      /* Option window entries */
    case 10:
      if (-1 !=
          (j = popup_menu (widget, "TV Norm", grabbers[grabber]->norms))) {
        set_norm (j);
	if (cur_sender != -1) channels[cur_sender]->norm = cur_norm;
      }
      break;

    case 11:
      if (-1 != (j = popup_menu (widget, "Video Source",
                                 grabbers[grabber]->inputs))) {
	printf("source:%d\n", j);
        set_source (j);
	if (cur_sender != -1) channels[cur_sender]->source = cur_input;
      }
      break;

    case 12:
      if (-1 != (j = popup_menu (widget, "Freq table", chan_names)))
        set_freqtab (j);
      break;

    case 13:
      if (-1 != (j = popup_menu (widget, "Audio", stereo)))
        {
          change_audio (j);
        }
      break;

    case 14:
      if (-1 != (j = popup_menu (widget, "Capture", cap_list)))
        {
	  if(!is_divx_in_progress())
	    set_capture (j, 1);
        }
      break;

    case 15:
      if (-1 != (j = popup_menu (widget, "Deinterlace", deinterlace_list)))
        {
          set_deinterlace (j);
        }
      break;

    case 16:
      if (-1 != (j = popup_menu (widget, "Stay on Top", yes_no_list)))
        {
          set_stayontop (j);
        }
      break;

    case 17:
      if (-1 != (j = popup_menu (widget, "Record movie", record_list)))
        {
          record_movie (j);
        }
      break;

    case 18:
      if (-1 != (j = popup_menu (widget, "Window Decoration", yes_no_list)))
        {
          set_decoration (j);
        }
      break;

    case 19:
      if (-1 != (j = popup_menu (widget, "Subtitles Page", subpageno_list)))
        {
          set_subpageno (j);
        }
      break;

    case 20:
      if (-1 != (j = popup_menu (widget, "Teletext", alevt_list)))
        {
          select_alevt (j);
        }
      break;

    case 21:
      if (-1 != (j = popup_menu (widget, "Channel Hopping", zap_list)))
        {
          select_zap (j);
        }
      break;

    case 22:
      if (-1 != (j = popup_menu (widget, "Grab an Image", grab_list)))
        {
	switch (j)
	  {
	    case 0:
              select_snap(0,0); // ppm + win: Ctrl + G
              break;

            case 1:
              select_snap(0,1); // ppm + full: G
              break;

            case 2:
              select_snap(1,0); // jpeg + win: Ctrl+J
              break;

            case 3:
              select_snap(1,1); // jpeg + full: J
              break;

	    default:
              break;
	  }
        }
      break;

    case 23:
      if (-1 != (j = popup_menu (widget, "Simple Actions", simple_actions_list)))
        {
	char *tok;
	int argc;

        switch (j)
	  {
	    case 0:
	      tok = "mute";
	      argc = 1;
              VolumeAction (NULL, NULL, &tok, &argc); // audio mute / (un)mute : A
              break;
	      
	    case 1:
	      tok = "tvmute";
	      argc = 1;
              VolumeAction (NULL, NULL, &tok, &argc); // audio mute + TVMUTE / (un)mute +TVMUTE : Shift+A
              break;	      

            case 2:
              ShowtimeAction (NULL, NULL, NULL, NULL); // show time : H
              break;

            case 3:
              PointerAction (NULL, NULL, NULL, NULL); // mouse pointer visible / hidden : M
	      notitle = 1;
              break;

            case 4:
              FullScreenAction (NULL, NULL, NULL, NULL); // fullscreen on / off : F
	      notitle = 1;
	      break;

	    default:
              break;
	  }
        }
      break;

    default:
      break;
    }

  if (title[0] != 0 && notitle == 0)
    set_timer_title ();
}

void
jump_scb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  char *name;
  int value;
  char *msg = (char *)NULL;

  name = XtName (XtParent (widget));
  value = (int) (*(float *) call_data * 65535);
#if 0
  fprintf (stderr, "jump to %f (%s/%d)\n", *(float *) call_data, name, value);
#endif

  if (0 == strcmp ("color", name))
    set_picparams (value, -1, -1, -1);

  else if (0 == strcmp ("contrast", name))
    set_picparams (-1, -1, -1, value);

  else if (0 == strcmp ("bright", name))
    set_picparams (-1, value, -1, -1);

  else if (0 == strcmp ("hue", name))
    set_picparams (-1, -1, value, -1);

  else if (0 == strcmp ("volume", name))
    {
      //cur_mute = 0;
      cur_volume = *(float *) call_data * 100 + 0.5;
      if (plugin != NULL)
        msg = plugin->use_alternate();

      set_volume ();
    }

}

void
scroll_scb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  int move = (int) call_data;
  Dimension length;
  float shown, top1, top2;

  XtVaGetValues (widget,
                 XtNlength, &length,
                 XtNshown, &shown, XtNtopOfThumb, &top1, NULL);

  top2 = top1 + (float) move / length / 5;
  if (top2 < 0)
    top2 = 0;
  if (top2 > 1)
    top2 = 1;

#if 0
  fprintf (stderr, "scroll by %d\tlength %d\tshown %f\ttop %f => %f\n",
           move, length, shown, top1, top2);
#endif

  jump_scb (widget, clientdata, &top2);
}

void
OptionsAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  static int mapped = 0, first = 1;

  if (event && event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Options: wm_save_yourself\n");
          XSetCommand (XtDisplay (opt_shell), XtWindow (opt_shell), NULL, 0);
          return;
        }
    }

  if (mapped)
    {
      XtPopdown (opt_shell);
      mapped = 0;
    }
  else
    {
      XtPopup (opt_shell, XtGrabNone);
      mapped = 1;
      if (first)
        {
          XSetWMProtocols (XtDisplay (opt_shell), XtWindow (opt_shell),
                           wm_protocols, 2);
          first = 0;
        }
    }
}

void
create_optwin ()
{
  Widget c, p;

  opt_shell = XtVaAppCreateShell ("Options", "Xawdecode",
                                  topLevelShellWidgetClass,
                                  dpy, XtNclientLeader, app_shell,
				  XtNvisual, vinfo->visual,
				  XtNcolormap, colormap,
				  XtNdepth, vinfo->depth, NULL);
  opt_paned = XtVaCreateManagedWidget ("paned", panedWidgetClass, opt_shell,
                                       NULL);

  c = XtVaCreateManagedWidget ("l_main_actions", commandWidgetClass, opt_paned,
                           PANED_FIX, NULL);	   
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_help);
  
  c_simple_actions = XtVaCreateManagedWidget ("simple_actions", commandWidgetClass, opt_paned,
                                         PANED_FIX, NULL);
  XtAddCallback (c_simple_actions, XtNcallback, menu_cb, (XtPointer) 23);


if (wm_stay_on_top)
  {
    c_stayontop = XtVaCreateManagedWidget ("stayontop", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
    XtAddCallback (c_stayontop, XtNcallback, menu_cb, (XtPointer) 16);

  }


  c_decoration = XtVaCreateManagedWidget ("decoration", commandWidgetClass, opt_paned,
                                         PANED_FIX, NULL);
  XtAddCallback (c_decoration, XtNcallback, menu_cb, (XtPointer) 18);


  c_record = XtVaCreateManagedWidget ("record", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
  XtAddCallback (c_record, XtNcallback, menu_cb, (XtPointer) 17);

  
  c_togglesub = XtVaCreateManagedWidget ("togglesub", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c_togglesub, XtNcallback, action_cb, (XtPointer) & call_togglesub);


  c_subpageno = XtVaCreateManagedWidget ("subpageno", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
  XtAddCallback (c_subpageno, XtNcallback, menu_cb, (XtPointer) 19);


  c_alevt = XtVaCreateManagedWidget ("teletext", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c_alevt, XtNcallback, menu_cb, (XtPointer) 20);


  c_graball = XtVaCreateManagedWidget ("graball", commandWidgetClass, opt_paned,
                                         PANED_FIX, NULL);
  XtAddCallback (c_graball, XtNcallback, menu_cb, (XtPointer) 22);


  c_zap = XtVaCreateManagedWidget ("zapping", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c_zap, XtNcallback, menu_cb, (XtPointer) 21);

#ifdef USE_LIBXOSD
  c_xosdaction = XtVaCreateManagedWidget ("Xosd", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c_xosdaction, XtNcallback, action_cb, (XtPointer) & call_xosdaction);
#endif  
  
  c = XtVaCreateManagedWidget ("l_channel_options", labelWidgetClass, opt_paned,
                           PANED_FIX, NULL);

  c_norm = XtVaCreateManagedWidget ("norm", commandWidgetClass, opt_paned,
                                    PANED_FIX, NULL);
  XtAddCallback (c_norm, XtNcallback, menu_cb, (XtPointer) 10);


  c_input = XtVaCreateManagedWidget ("input", commandWidgetClass, opt_paned,
                                     PANED_FIX, NULL);
  XtAddCallback (c_input, XtNcallback, menu_cb, (XtPointer) 11);


  c_freq = XtVaCreateManagedWidget ("freq", commandWidgetClass, opt_paned,
                                    PANED_FIX, NULL);
  XtAddCallback (c_freq, XtNcallback, menu_cb, (XtPointer) 12);


  c_audio = XtVaCreateManagedWidget ("audio", commandWidgetClass, opt_paned,
                                     PANED_FIX, NULL);
  XtAddCallback (c_audio, XtNcallback, menu_cb, (XtPointer) 13);


  c_cap = XtVaCreateManagedWidget ("cap", commandWidgetClass, opt_paned,
                                   PANED_FIX, NULL);
  XtAddCallback (c_cap, XtNcallback, menu_cb, (XtPointer) 14);


#ifdef HAVE_XV
  c_deinterlace = XtVaCreateManagedWidget ("deinterlace", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
  if (disable_xv == 1)
    XtVaSetValues (c_deinterlace, XtNsensitive, False, NULL);	   
  XtAddCallback (c_deinterlace, XtNcallback, menu_cb, (XtPointer) 15);
#endif


  p = XtVaCreateManagedWidget ("bright", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l_bright = XtVaCreateManagedWidget ("lbright", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_bright = XtVaCreateManagedWidget ("sbright", scrollbarWidgetClass, p,
                                      PANED_FIX, NULL);

  XtAddCallback (s_bright, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_bright, XtNscrollProc, scroll_scb, NULL);


  p = XtVaCreateManagedWidget ("hue", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l_hue = XtVaCreateManagedWidget ("lhue", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_hue = XtVaCreateManagedWidget ("shue", scrollbarWidgetClass, p,
                                   PANED_FIX, NULL);

  XtAddCallback (s_hue, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_hue, XtNscrollProc, scroll_scb, NULL);


  p = XtVaCreateManagedWidget ("contrast", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l_contrast = XtVaCreateManagedWidget ("lcontrast", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_contrast = XtVaCreateManagedWidget ("scontrast", scrollbarWidgetClass, p,
                                        PANED_FIX, NULL);

  XtAddCallback (s_contrast, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_contrast, XtNscrollProc, scroll_scb, NULL);


  p = XtVaCreateManagedWidget ("color", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l_color = XtVaCreateManagedWidget ("lcolor", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_color = XtVaCreateManagedWidget ("scolor", scrollbarWidgetClass, p,
                                     PANED_FIX, NULL);

  XtAddCallback (s_color, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_color, XtNscrollProc, scroll_scb, NULL);


  p = XtVaCreateManagedWidget ("volume", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l_volume = XtVaCreateManagedWidget ("lvolume", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_volume = XtVaCreateManagedWidget ("svolume", scrollbarWidgetClass, p,
                                      PANED_FIX, NULL);

  XtAddCallback (s_volume, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_volume, XtNscrollProc, scroll_scb, NULL);


  c = XtVaCreateManagedWidget ("xfreeparamswin", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_xfreeparams);


  c = XtVaCreateManagedWidget ("editorwin", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_editor);


  c = XtVaCreateManagedWidget ("chanwin", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_chan);



  if (plugin != NULL)
    plugin->add_entry(opt_paned);

  c = XtVaCreateManagedWidget ("save_config", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, save_cb, (XtPointer) NULL);

  c = XtVaCreateManagedWidget ("quit", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);

  XtAddCallback (c, XtNcallback, ExitCB, NULL);
}

/* --- END Xaw: Main Options GUI -------------------------------------- */
/* --- END Xaw: Main Options GUI -------------------------------------- */
/* --- END Xaw: Main Options GUI -------------------------------------- */


/* ------------- init functions ----------------------------------------*/

static void
xfree_init ()
{
  int flags, foo, bar, i, ma, mi;

#ifdef HAVE_LIBXXF86DGA
  if (!noDGA)
    {
      if (XF86DGAQueryExtension (dpy, &foo, &bar))
        {
          XF86DGAQueryDirectVideo (dpy, XDefaultScreen (dpy), &flags);
          if (flags & XF86DGADirectPresent)
            {
              XF86DGAQueryVersion (dpy, &ma, &mi);
              fprintf (stderr, "DGA: server=%d.%d, include=%d.%d\n",
                       ma, mi, XF86DGA_MAJOR_VERSION, XF86DGA_MINOR_VERSION);
              if ((ma != XF86DGA_MAJOR_VERSION) || (mi != XF86DGA_MINOR_VERSION))
#ifdef CHECK_XFREE_EXT
                fprintf (stderr, "DGA: version mismatch -- disabled\n");
              else
#else
                fprintf (stderr, "DGA: WARNING: version mismatch !!!\n");
#endif
                have_dga = 1;
            }
        }
    }
#endif
#ifdef HAVE_LIBXXF86VM
  if (XF86VidModeQueryExtension (dpy, &foo, &bar))
    {
      XF86VidModeQueryVersion (dpy, &ma, &mi);
      fprintf (stderr, "VidMode: server=%d.%d, include=%d.%d\n",
               ma, mi, XF86VIDMODE_MAJOR_VERSION, XF86VIDMODE_MINOR_VERSION);
      if ((ma != XF86VIDMODE_MAJOR_VERSION)
          || (mi != XF86VIDMODE_MINOR_VERSION))
#ifdef CHECK_XFREE_EXT
        fprintf (stderr, "VidMode: version mismatch -- disabled\n");
      else
#else
        fprintf (stderr, "VidMode: WARNING: version mismatch !!!\n");
#endif
        {
          have_vm = 1;
          fprintf (stderr, "  available video mode(s):");
          XF86VidModeGetAllModeLines (dpy, XDefaultScreen (dpy),
                                      &vm_count, &vm_modelines);
          for (i = 0; i < vm_count; i++)
            {
              fprintf (stderr, " %dx%d",
                       vm_modelines[i]->hdisplay, vm_modelines[i]->vdisplay);
            }
          fprintf (stderr, "\n");
        }
    }
#endif
}

void
xfree_xinerama_init(Display *dpy)
{
#ifdef HAVE_LIBXINERAMA
    int foo,bar,i;

    if (XineramaQueryExtension(dpy,&foo,&bar) &&
	XineramaIsActive(dpy)) {
	xinerama = XineramaQueryScreens(dpy,&nxinerama);
	for (i = 0; i < nxinerama; i++) {
	    fprintf(stderr,"xinerama %d: %dx%d+%d+%d\n",
		    xinerama[i].screen_number,
		    xinerama[i].width,
		    xinerama[i].height,
		    xinerama[i].x_org,
		    xinerama[i].y_org);
	}
    }
#endif
}

static void
grabber_init ()
{
  int sw, sh;
  void *base = NULL;
  int width = 0, depth = 0;
#ifdef HAVE_LIBXXF86DGA

  if (have_dga)
    {
      int bank_size, ram_size;
      XF86DGAGetVideoLL (dpy, XDefaultScreen (dpy), (int *) &base,
                         &width, &bank_size, &ram_size);
      video_base = base;
      video_size = bank_size;
      direct_xsize = width;
    }
    
#endif
  sw = XtScreen (app_shell)->width;
  sh = XtScreen (app_shell)->height;

  if (0 == width)
    width = sw;
  switch (x11_native_format)
    {
    case VIDEO_GRAY:
    case VIDEO_RGB08:
      depth = 8;
      break;
    case VIDEO_RGB15:
      depth = 15;
      break;
    case VIDEO_RGB16:
      depth = 16;
      break;
    case VIDEO_RGB24:
      depth = 24;
      break;
    case VIDEO_RGB32:
      depth = 32;
      break;
    }
  width *= (depth + 7) / 8;
  fprintf (stderr, "x11: %dx%d, %d bit/pixel, %d byte/scanline\n",
           sw, sh, depth, width);

  if(direct_video) {
    if(video_base == NULL)
      {fprintf(stderr, "video_base not found\n"); exit(1);}
    if(0 == direct_xsize) direct_xsize=sw;
    if(0 == video_size) video_size = sh * direct_xsize * depth / 8;
    memfd=open("/dev/mem", O_RDWR);
    if(memfd<0) {perror("open mem"); exit(1);}
    if(debug)
      fprintf(stderr,"direct_video: base=%p video_size=%d direct_xsize=%d\n" ,
	      video_base, video_size, direct_xsize);
    video_base=mmap(NULL,video_size, PROT_READ|PROT_WRITE, MAP_SHARED, memfd,(off_t) video_base);
    if(video_base==MAP_FAILED) {perror("mmap mem"); exit(1);}
  }

#ifndef HAVE_V4L
  {
    int j;
    for(j=0;j<sizeof(grabbers)/sizeof(struct GRABBERS*);j++)
      if(grabbers[j] == &grab_v4l || grabbers[j] == &grab_v4l2)
	grabbers[j] = NULL;
  }
#endif

  for (grabber = 0;
       grabber < sizeof (grabbers) / sizeof (struct GRABBERS *); grabber++)
    {
      if (grabbers[grabber]!=NULL &&
	  -1 != grabbers[grabber]->grab_open
          (&device, sw, sh, x11_native_format, x11_pixmap_format, base,
           width ? width : sw))
        break;
    }
  if (grabber == sizeof (grabbers) / sizeof (struct GRABBERS *))
    {
      fprintf (stderr, "@@@@ no video grabber device available\n");
      if(v4l2)
	fprintf(stderr, "for v4l2, you need a recent driver, "
		"see http://bytesex.org/v4l/\n");
#ifdef HAVE_VIDEO_XV
      if(xvtv)
	fprintf(stderr, "for xvtv, you need an X driver for your TV-card\n"
		"do 'man v4l' for a common installation\n");
#endif
      exit (1);
    }
  if(grabbers[grabber]==&grab_dummy)
    {
      fprintf(stderr, "no real video grabber device available\n");
      fprintf(stderr, "USE DUMMY DRIVER !\n");
    }
  fprintf(stderr, "*** GRABBER DEVICE TYPE = %s\n", grabbers[grabber]->name);
  if(plugin !=NULL &&
     grabbers[grabber]!=&grab_v4l && grabbers[grabber]!=&grab_v4l2
     && grabbers[grabber]!=&grab_avi
#ifdef HAVE_BKTR
     && grabbers[grabber]!=&grab_bktr
#endif
     )
    {
      printf("plugin canceled, because it only works with v4l or v4l2!\n");
      plugin = NULL;
    }

#ifdef HAVE_VIDEO_XV
  if(xvtv_overlay == -1)
    xvtv_overlay = grabbers[grabber]==&grab_v4l2 && xv_video_name &&
      strcasecmp(xv_video_name,"video4linux") == 0;
  if(!xvtv_overlay)
    if(grabbers[grabber]!=&grab_xv) have_video_xv=0;
#endif

  /* Start sound acquisition */
  if (grabbers[grabber]->grab_audio)
    grabbers[grabber]->grab_audio (0, 65535, NULL);
}


void
display_help_message (FILE *fp)
{
  int i;

  fprintf(fp, "Valid Options are:\n\n");
  i = 0;
  while (help_msg[i] != NULL)
    {
      fprintf(fp, "%s\n\n", help_msg[i]);
      i++;
    }

  if (plugin)
    plugin->display_help_message(fp);

}

void load_plugin (void)
{
// 1.4.0
#define EXPECTED 0x010400

#define MAJOR(a) ( ( (a) >> 16 )&0xFF)
#define MINOR(a) ( ( (a) >> 8 )&0xFF )
#define SUB(a)   ( (a)&0xFF )

  char *error;
  unsigned int *plugin_version;
  int version_error = 0;

  if(plugfile == NULL) return;
#ifndef RTLD_NOW /* For OpenBSD */
#define RTLD_NOW 0
#endif
#ifdef DL_ADD_UNDERSCORE
#define DL_UND(x) ("_" x)
#else
#define DL_UND(x) (x)
#endif
  hPlugin = dlopen(plugfile, RTLD_NOW);
  if (!hPlugin)
    {
      error = dlerror();
      if(!strstr(error,"No such file") || plugfile != plugdef)
	fprintf(stderr, "%s\n", error);
      fprintf(stderr, "No plugin found.\n");
      if(plugfile != plugdef) exit(1);
      plugin = NULL;
    }
  else
    {
      plugin_version = dlsym(hPlugin, DL_UND("version"));
      if ((error = dlerror()) != NULL)
        {
	if (debug||1)
	  fprintf(stderr, "error: %s\n", error);
          fprintf(stderr,
                  "WARNING: A plugin has been find but is unable to provide its version number.\n"
                  "         Make sure you have the latest plugin installed.\n");
          version_error = 1;
        }
      else if (*plugin_version < EXPECTED)
        {
          fprintf(stderr,
                  "WARNING: Plugin claims to be %d.%d.%d but %d.%d.%d at least is expected.\n",
                  MAJOR(*plugin_version), MINOR(*plugin_version), SUB(*plugin_version),
                  MAJOR(EXPECTED), MINOR(EXPECTED), SUB(EXPECTED));
          version_error = 1;
        }

      if (!version_error)
        {
          plugin = dlsym(hPlugin, DL_UND("xawdecode"));
          if ((error = dlerror()) != NULL)
            {
              fprintf(stderr, "%s\n", error);
	  if (debug)
		fprintf(stderr, "WARNING: a plugin has been find but does not appear to be usable.\n");
              plugin = NULL;
            }
        }
      else
        {
          dlclose(hPlugin);
          hPlugin = NULL;
          plugin = NULL;
          fprintf(stderr, "WARNING: plugin has been disabled.\n");
        }
    }
}

int
check_mmx(void)
{
  int mmx_flags;

  if ( (mmx_flags = mm_accel ()) == 0 )
    {
      fprintf (stderr, "No MMX detected: deinterlacing will not be available!\n\n");
      return 0;
    }

  if (mmx_flags & MM_ACCEL_X86_MMX)
    fprintf(stderr, "MMX, ");
  if (mmx_flags & MM_ACCEL_X86_SSE)
    fprintf(stderr, "SSE, ");
  if (mmx_flags & MM_ACCEL_X86_MMXEXT)
    fprintf(stderr, "AMD MMX extensions, ");
  if (mmx_flags & MM_ACCEL_X86_SSE2)
    fprintf(stderr, "SSE2, ");
  if (mmx_flags & MM_ACCEL_X86_3DNOW)
    fprintf(stderr, "3DNOW, ");
  fprintf(stderr, "have been detected.\n");

  return mmx_flags;
}

#ifdef HAVE_V4L
void
check_device_old_way(void)
{
#ifdef HAVE_DEVFS

  struct stat buf;

  /* Check for really default available video device */
  if (stat (device.video, &buf) != 0)
    {
      /* default video device does not exist at all */
      /* last chance ? */
      device.video = "/dev/v4l/video0";
    }


  /* Check for really default available vbi device */
  if (stat (device.vbi, &buf) != 0)
    {
      /* default vbi device does not exist at all */
      /* last chance ? */
      device.vbi = "/dev/v4l/vbi0";
    }

#else

  struct stat buf;

  /* Check for really default available video device */
  if (stat (device.video, &buf) == 0)
    {
      /* is it a directory */
      if (S_ISDIR (buf.st_mode))
        {
          /* New fucking idea of Mandrake and RedHat */
          device.video = "/dev/video/video0";

          /* Quickly check if that device exists */
          if (stat (device.video, &buf) != 0)
            {
              /* No, then defaults to /dev/video0 (last chance ?) */
              device.video = "/dev/video0";
            }
        }
    }
  else
    /* default video device does not exist at all */
    {
      /* last chance ? */
      device.video = "/dev/video0";
    }


  /* Check for really default available vbi device */
  if (stat (device.vbi, &buf) == 0)
    {
      /* is it a directory */
      if (S_ISDIR (buf.st_mode))
        {
          /* New fucking idea of Mandrake and RedHat */
          device.vbi = "/dev/video/vbi0";

          /* Quickly check if that device exists */
          if (stat (device.vbi, &buf) != 0)
            {
              /* No, then defaults to /dev/vbi0 (last chance ?) */
              device.vbi = "/dev/vbi0";
            }
        }
    }
  else
    /* default vbi device does not exist at all */
    {
      /* last chance ? */
      device.vbi = "/dev/vbi0";
    }

#endif
  if (debug)
    {
      fprintf(stderr, "Selected default video device : %s\n", device.video);
      fprintf(stderr, "Selected default vbi device   : %s\n", device.vbi);
    }
}

void
check_device(void)
{
  int n;
  struct dirent **namelist;
  FILE *fp;
  char line [128];
  char *test_string;
  char **test_device;

  /* Read entries in /proc/video/dev */
  n = scandir("/proc/video/dev", &namelist, 0, 0);
  if (debug)
    fprintf(stderr, "Get %d files in /proc/video/dev\n", n);
  if (n <= 0)
    {
      // something odd occured, fallback to old detection way
      if (n<0) perror("scandir");
      check_device_old_way();
      return;
    }
  else
    {
      while (n--)
        {
          if ((strcmp(namelist[n]->d_name, "..")==0)||(strcmp(namelist[n]->d_name, ".")==0))
            break;

          if (debug)
            fprintf(stderr, "Checking file /proc/video/dev/%s\n", namelist[n]->d_name);
          if (strncmp(namelist[n]->d_name, "video", 5)== 0)
            {
              test_string = "VID_TYPE_TUNER";
              test_device = &device.video;
            }
          else if (strncmp(namelist[n]->d_name, "vbi", 3)== 0)
            {
              test_string = "VID_TYPE_TELETEXT";
              test_device = &device.vbi;
            }
          else
            {
              test_string = NULL;
              test_device = NULL;
            }

          if (test_string != NULL)
            {
              sprintf(line, "/proc/video/dev/%s", namelist[n]->d_name);
              fp = fopen(line, "r");
              while (NULL != fgets (line, 127, fp))
                {
                  line[strlen(line)-1] = 0;
                  if (debug)
                    fprintf(stderr, "Checking line: '%s'\n", line);
                  if ( (strncmp(line, "type", 4) == 0) && strstr(line, test_string) )
                    {
                      if (debug)
                        fprintf(stderr, "Bingo!\n");
                      *test_device = malloc(16);
#ifndef HAVE_DEVFS
                      sprintf(*test_device, "/dev/%s", namelist[n]->d_name);
#else
                      sprintf(*test_device, "/dev/v4l/%s", namelist[n]->d_name);
#endif
                    }
                }
              fclose(fp);
            }
          free(namelist[n]);
        }
      free(namelist);
    }

  if (debug)
    {
      fprintf(stderr, "Selected default video device : %s\n", device.video);
      fprintf(stderr, "Selected default vbi device   : %s\n", device.vbi);
    }
}
#endif

#define INCRARG(i) if(++i>=argc) \
{display_help_message(stderr); exit(0);} arg=argv[i];

/* options which must be parsed again after reading config file*/

static int parse_opts(int argc,char *argv[],int *i)
{
  char *arg=argv[*i];
  if (strcmp (arg, "-rec_fps") == 0)
    {
      INCRARG(*i);
      setfps(atof(arg));
    }
  else if (strcmp (arg, "-rec_width") == 0)
    {
      INCRARG(*i);
      divx.width=atol(arg);
      divx.width=((int)(divx.width / 8.0 + 0.5 )) * 8;
      if(divx.width == 0)
	divx.width= ((int) (4.0 * divx.height / 24 + 0.5)) * 8;
    }
  else if (strcmp (arg, "-rec_height") == 0)
    {
      INCRARG(*i);
      divx.height=atol(arg);
      divx.height=(int)(divx.height / 2.0 + 0.5 ) * 2;
      if(divx.height == 0)
	divx.height = ((int)(3.0 * divx.width / 8 + 0.5)) * 2; //must be even
    }
  else if (strcmp (arg, "-rec_videobr") == 0)
    {
      INCRARG(*i);
      divx.bitrate=atol(arg)*1000L;
    }
  else if (strcmp (arg, "-rec_stereo") == 0)
    {
      INCRARG(*i);
      divx.stereo=str_to_int(arg,booltab);
      if(divx.compress_audio == -1)
	{display_help_message(stderr); exit(1);}
    }
  else if (strcmp (arg, "-rec_audiobuf") == 0)
    {
      INCRARG(*i);
      divx.audio_buffer_size=atoi(arg);
    }
  else if (strcmp (arg, "-rec_fragments") == 0)
    {
      INCRARG(*i);
      divx.audio_fragments=atoi(arg);
    }
  else if (strcmp (arg, "-rec_fragmentsize") == 0)
    {
      INCRARG(*i);
      divx.audio_sizefragment=atoi(arg);
    }
  else if (strcmp (arg, "-rec_mp3") == 0)
    {
      INCRARG(*i);
      divx.compress_audio=str_to_int(arg,booltab);
      if(divx.compress_audio == -1)
	{display_help_message(stderr); exit(1);}
    }
  else if (strcmp (arg, "-rec_mp3cbr") == 0)
    {
      INCRARG(*i);
      divx.mp3_bitrate=atoi(arg);
      divx.mp3_vbr=0;
    }
  else if (strcmp (arg, "-rec_mp3vbr") == 0)
    {
      INCRARG(*i);
      divx.mp3_vbr_quality=atoi(arg);
      divx.mp3_quality=2;
      divx.mp3_vbr=1;
    }
  else if (strcmp (arg, "-rec_vcodec") == 0)
    {
      int j;
      struct {char *nom;int numcodec;} codecs[]= {
#ifdef HAVE_FFMPEG
	{"ffmpeg_mpeg4",FFMPEG_MPEG4},
	{"ffmpeg_mpeg1",FFMPEG_MPEG1},
	{"ffmpeg_huffyuv",FFMPEG_HUFFYUV},
#endif
#ifdef HAVE_XVID
	{"xvid",XVID},
#endif
#ifdef HAVE_DIVX4LINUX
	{"divx4linux",DIVX4LINUX},
#endif
	{"uncompressed",UNCOMPRESSED},
	{NULL,0}};
      INCRARG(*i);
      for(j=0;codecs[j].nom;j++) {
	printf("%s\n",codecs[j].nom);
	if(!strcmp(arg,codecs[j].nom)) break;
      }
      if(!codecs[j].nom)
	{
	  fprintf(stderr,"codec %s inconnu\n",arg);
	  exit(1);
	}
	  divx.codec=codecs[j].numcodec;
    }
  else if (strcmp (arg, "-rec_display") == 0)
    {
      INCRARG(*i);
      divx.display_frames = str_to_int(arg,booltab);
      if(divx.display_frames == -1)
	{display_help_message(stderr); exit(1);}
    }
  else if (strcmp (arg, "-rec_maxgap") == 0)
    {
      INCRARG(*i);
      divx.maxgap=atof(arg);
    }
  else if (strcmp (arg, "-rec_delay") == 0)
    {
      INCRARG(*i);
      divx.delay=atof(arg);
    }
  else if (strcmp (arg, "-rec_sub") == 0)
    {
      INCRARG(*i);
      divx.sub = str_to_int(arg,booltab);
      if(divx.sub == -1)
	{display_help_message(stderr); exit(1);}
    }
  else if (strcmp (arg, "-rec_chg") == 0)
    {
      INCRARG(*i);
      divx.chg = str_to_int(arg,booltab);
      if(divx.chg == -1)
	{display_help_message(stderr); exit(1);}
    }
  else if (strcmp (arg, "-rec_filename") == 0)
    {
      INCRARG(*i);
      divx.filename=arg;
    }
  else if (strcmp (arg, "-alevt_arg") == 0)
    {
      INCRARG(*i);
      strcpy(alevtarg,arg);
      alevt1st = 1;
    }
  else if (strcmp (arg, "-rec_stream") == 0)
    {
      INCRARG(*i);
      divx.stream = str_to_int(arg,booltab);;
    }
  else if (strcmp (arg, "-rec_http_port") == 0)
    {
      INCRARG(*i);
      divx.http_port=atoi(arg);
    }
  else if (strcmp (arg, "-capt_width") == 0)
    {
      INCRARG(*i);
      width_capture_max = atoi(arg);
    }
  else if (strcmp (arg, "-capt_height") == 0)
    {
      INCRARG(*i);
      height_capture_max = atoi(arg);
    }
  else if (strcmp (arg, "-force_capt_width") == 0)
    {
      INCRARG(*i);
      width_capture = atoi(arg);
    }
  else if (strcmp (arg, "-force_capt_height") == 0)
    {
      INCRARG(*i);
      height_capture = atoi(arg);
    }
  else if (strcmp (arg, "-subpageno") == 0)
    {
      INCRARG(*i);
      subtitles_pageno_str=arg;
    }
  else if(strcmp (arg, "-ybar") == 0)
    {
      INCRARG(*i);
      set_ybar_ratio(atoi(arg));
    }
  else if (strcmp (arg, "-restoresnd") == 0)
    {
      INCRARG(*i);
      restoresnd = str_to_int(arg,booltab);;
    }
  else if (strcmp (arg, "-noxawpopup") == 0)
    {
      xawpopup = 0;
    }
  else if(plugin == NULL ||
	  plugin->parse_cmdline(i, argv) == -1)
    {
      return 0;
    }
  return 1;
}

static Boolean docmd (XtPointer data) {
  printf("done\n");
  if(cmd) {do_command(cmd);cmd=NULL;}
  return -1; /* executed once...*/
}

/*----------------------------------------------------------------------*/
/*--- main function-----------------------------------------------------*/
/*----------------------------------------------------------------------*/

int
main (int argc, char *argv[])
{
  int i, j, noconf, fullscreen, nodecoration, nomouse;
  char *arg;
  char xawdecode_v4l_conf[128] = "xawdecode_v4l-conf";
  Dimension w;
#ifdef HAVE_XPM
  Pixmap icon_pixmap;
  Pixmap icon_shapemask;
#endif
  struct utsname uts;
  struct CHANNEL last_channel;
  int cmdline_probe_memcpy = -1;
  struct sigaction sa;

  progname = strdup (argv[0]);

  uname(&uts);
  fprintf (stderr, "\nThis is %s %s running on %s/%s (%s).\n",
           PACKAGE, VERSION, uts.sysname, uts.machine, uts.release);


#ifndef _POSIX_THREAD_IS_GNU_PTH
  /* with GNU Pth (GNU Portable Threads)
     the call of XInitThread causes a segfault on the exit
     (at least on OpenBSD 3.0)
   */
  XInitThreads ();
#endif


  app_shell = XtAppInitialize (&app_context, "Xawdecode", NULL, 0,    /* opt_desc, 7, */
                               &argc, argv, NULL /* fallback_res */ ,
                               NULL, 0);
  /* signal handler */
  memset(&sa, 0, sizeof(sa));
  sa.sa_handler = sigint_handler;
  sa.sa_flags = SA_RESTART;
  sigaction(SIGINT,  &sa, NULL);
  sa.sa_handler = sigpipe_handler;
  sigaction(SIGPIPE, &sa, NULL);

#ifdef HAVE_V4L
  /* Check for really default available device */
  check_device();
#endif

  plugfile = plugdef;
  for (i = 1; i < argc; i++)
    {
      if (strcmp (argv[i], "-noplugin") == 0)
        {
          plugfile = NULL;
        }
      else if(strcmp (argv[i], "-plugin") == 0)
	{
          INCRARG(i);
	  plugfile = arg;
	}
    }

  load_plugin();

  /* parse options */
  debug = noconf = fullscreen = nodecoration =nomouse = 0;
  xfree_ext = 1;

  for (i = 1; i < argc; i++)
    {
      arg = argv[i];
      if (strcmp (arg, "-x") == 0)
        {
          xfree_ext = 0;
        }
      else if (strcmp (arg, "-v") == 0)
        {
          INCRARG(i);
          debug = strtol (arg, (char **) NULL, 10);
        }
      else if (strcmp (arg, "-n") == 0)
        {
          noconf = 1;
        }
      else if (strcmp (arg, "-d") == 0)
        {
          noDGA = 1;
        }
      else if (strcmp (arg, "-directvideo") == 0)
        {
          direct_video = 1;
          disable_xv = 1;
        }
      else if (strcmp (arg, "-D") == 0)
        {
          INCRARG(i);
	  sscanf(arg,"%p",&video_base);
	  strcat (xawdecode_v4l_conf, " -a ");
          strncat (xawdecode_v4l_conf, arg, 20);
        }
      else if (strcmp (arg, "-Dw") == 0)
        {
          INCRARG(i);
	  direct_xsize=atoi(arg);
	  strcat (xawdecode_v4l_conf, " -w ");
          strncat (xawdecode_v4l_conf, arg, 20);
        }
      else if (strcmp (arg, "-m") == 0)
        {
          nomouse = 1;
        }
      else if (strcmp (arg, "-f") == 0)
        {
          fullscreen = 1;
	  oldswitch = 1;	   
        }
      else if (strcmp (arg, "-nowd") == 0)
         {
           nodecoration = 1;
         }
      else if (strcmp (arg, "-b") == 0)
        {
          INCRARG(i);
	  bpp = strtol (arg, (char **) NULL, 10);
          /* xawdecode_v4l-conf needs this too */
          strcat (xawdecode_v4l_conf, " -b ");
          strcat (xawdecode_v4l_conf, arg);
        }
      else if (strcmp (arg, "-o") == 0)
        {
	  INCRARG(i);
          ppmfile = arg;
          jpegfile = arg;
        }
      else if (strcmp (arg, "-c") == 0)
        {
          INCRARG(i);
          device.video = arg;
          /* xawdecode_v4l-conf needs this too */
          //strcat (xawdecode_v4l_conf, " -c ");
          //strcat (xawdecode_v4l_conf, device);
#ifdef HAVE_VIDEO_XV
	  if(cmdline_xv_video_port == 0)
	    cmdline_xv_video_port = -1;
#endif
        }
      else if (strcmp (arg, "-C") == 0)
        {
          INCRARG(i);
          device.vbi = arg;
        }
      else if (strcmp (arg, "-novbi") == 0)
        {
          device.vbi = NULL;
        }
      else if ((strcmp (arg, "-no-xv") == 0) || (strcmp (arg, "-noxv") == 0))
        {
#ifdef HAVE_XV
          disable_xv = 1;
          fprintf (stderr, "Xv support disabled.\n");
#else
          fprintf (stderr,
                   "Xv support was not compiled in. Option ignored.\n");
#endif
        }
      else if (strcmp (arg, "-xvport") == 0)
        {
#ifdef HAVE_XV
          INCRARG(i);
          cmdline_xv_img_port = atoi(arg);
#else
          fprintf (stderr,
                   "Xv support was not compiled in. Option ignored.\n");
#endif
        }
#ifdef HAVE_VIDEO_XV
      else if (strcmp (arg, "-xvtvport") == 0)
        {
          INCRARG(i);
          cmdline_xv_video_port = atoi(arg);
        }
#endif
      else if (strcmp(arg, "-hwscan") == 0)
        {
          hwscan = 1;
        }
      else if (strcmp(arg, "-noplugin") == 0)
        {
          // just to avoid xawdecode exiting
        }
      else if(strcmp (argv[i], "-plugin") == 0)
	{
          INCRARG(i);  // just to avoid xawdecode exiting
	}
      else if (strcmp (arg, "-probe_memcpy") == 0)
        {
          cmdline_probe_memcpy = MEMCPY_PROBE;
        }
      else if ((strcmp(arg, "-h") == 0)||strcmp(arg, "--help") == 0)
        {
          fprintf (stdout, "\nUsage: %s [options]\n\n", argv[0]);
          display_help_message(stdout);
          exit(0);
        }
      else if (strcmp (arg, "-e") == 0)
        {
	  INCRARG(i);
	  cmd = arg;
        }
      else if (strcmp (arg, "-v4l2") == 0)
	{
	  for(j=0;j<sizeof(grabbers)/sizeof(struct GRABBERS*);j++)
	    if(grabbers[j] != &grab_v4l2) grabbers[j] = NULL;
	  v4l2 = 1;
	}
      else if (strcmp (arg, "-v4l1") == 0)
	{
	  for(j=0;j<sizeof(grabbers)/sizeof(struct GRABBERS*);j++)
	    if(grabbers[j] != &grab_v4l) grabbers[j] = NULL;
	  strcat (xawdecode_v4l_conf, " -1 ");
	}
#ifdef HAVE_VIDEO_XV
      else if (strcmp (arg, "-xvtv") == 0)
	{
	  for(j=0;j<sizeof(grabbers)/sizeof(struct GRABBERS*);j++)
	    if(grabbers[j] != &grab_xv) grabbers[j] = NULL;
	  xvtv = 1;
	}
      else if (strcmp (arg, "-xvtv_overlay") == 0)
	{
	  INCRARG(i);
	  xvtv_overlay = str_to_int(arg,booltab);
	  if(xvtv_overlay == -1)
	    {display_help_message(stderr); exit(1);}
	}
#endif
      else if (strcmp (arg, "-capture") == 0)
	{
	  INCRARG(i);
	  force_capture = str_to_int(arg,captab);
	  if(force_capture == -1)
	    {display_help_message(stderr); exit(1);}
	}
      else if (strcmp (arg, "-nbufs") == 0)
	{
	  INCRARG(i);
	  nbufs_default = atoi(arg);
	}
      else if (strcmp (arg, "-force_depth") == 0)
	{
	  INCRARG(i);
	  force_depth = atoi(arg);
	}
      else if (strcmp (arg, "-force_visual") == 0)
	{
	  INCRARG(i);
	  force_visual = str_to_int(arg,visuals_list);;
	  if(force_visual == -1)
	    {display_help_message(stderr); exit(1);}
	}
      else if (strcmp (arg, "-avi") == 0)
	{
	  INCRARG(i);
	  avifilename = arg;
	  for(j=0;j<sizeof(grabbers)/sizeof(struct GRABBERS*);j++)
	    if(grabbers[j] != &grab_avi) grabbers[j] = NULL;
	  device.vbi = NULL;
	}
      else if (strcmp (arg, "-avibench") == 0)
	{
	  avibench = 1;
	}
      else if (strcmp (arg, "-avi_audiofragments") == 0)
	{
	  INCRARG(i);
	  avi_audio_fragments=atoi(arg);
	}
      else if (strcmp (arg, "-avi_audiofragmentsize") == 0)
	{
	  INCRARG(i);
	  avi_audio_sizefragment=atoi(arg);
	}
      else if (strcmp (arg, "-avinoaudioout") == 0)
	{
	  avinoaudioout = 1;
	}
#ifdef USE_LIBXOSD
      else if (strcmp (arg, "-xosd") == 0)
	{
	  libxosd = 1; 
	}
#endif
      else if (strcmp (arg, "-sub") == 0)
	{
	  INCRARG(i);
	  subactive = str_to_int(arg,booltab);
	  if(subactive == -1)
	    {display_help_message(stderr); exit(1);}
	}
#ifdef HAVE_ALSA
      else if (strcmp (arg, "-noalsa") == 0)
	{
	  have_alsa = -1;
	}
#endif
#ifdef HAVE_BKTR
      else if (strcmp (arg, "-bktr_swap") == 0)
	{
	  bktr_swap = 1;
	}
      else if (strcmp (arg, "-bktr_yuvbug") == 0)
	{
	  bktr_yuvbug = 1;
	}
      else if (strcmp (arg, "-bktr_mode") == 0)
	{
	  INCRARG(i);
	  bktr_mode = atoi(arg);
	}
      else if (strcmp (arg, "-bktr_read") == 0)
	{
	  bktr_read = 1;
	}
#endif
      else if (strcmp (arg, "-doublekey") == 0)
	{
	  INCRARG(i);
	  doublekey = str_to_int(arg,booltab);
	}
      else if (strcmp (arg, "-doublekey_firstisone") == 0)
	{
	  INCRARG(i);
	  doublekey_firstisone = str_to_int(arg,booltab);;
	}
      else if (strcmp (arg, "-oldswitch") == 0)
	{
	  oldswitch = 1;
	}
      else if(!parse_opts(argc,argv,&i))
        {
	  fprintf (stderr, "\nUnknown option: '%s'.\n\n", arg);
	  fprintf (stderr, "Usage: %s [options]\n\n", argv[0]);
	  display_help_message(stderr);
	  exit (1);
	}
    }

#ifdef HAVE_VIDEO_XV
  if(cmdline_xv_video_port==-1)
    fprintf(stderr, "*** to enable xvtv or xvtv_overlay use xvtvport option\n");
#endif

  if(force_visual==StaticGray)
    strcat (xawdecode_v4l_conf, " -g");
  if(!debug)
    strcat (xawdecode_v4l_conf, " -q");

  // This is now done here as device may have been
  // modified either by the check_device function
  // or by supplying the -c switch
  strcat (xawdecode_v4l_conf, " -c ");
  strcat (xawdecode_v4l_conf, device.video);

  if (hwscan == 1)
    {
      fprintf(stderr,"looking for available devices\n\n");
      x11_init();
      grabber_scan(XtScreen (app_shell)->width, XtScreen (app_shell)->height);
    }

  if(debug) fprintf(stderr, "execution of \"%s\"\n", xawdecode_v4l_conf);
  switch (system (xawdecode_v4l_conf))
    {
    case -1:                    /* can't run */
      fprintf (stderr, "could'nt start xawdecode_v4l-conf\n");
      break;
    case 0:                    /* ok */
      break;
    default:                    /* non-zero return */
      fprintf (stderr, "xawdecode_v4l-conf had some trouble, "
               "trying to continue anyway\n");
      break;
    }

  XtAppAddActions (app_context, actionTable,
                   sizeof (actionTable) / sizeof (XtActionsRec));

  dpy = XtDisplay (app_shell);

  wm_protocols[0] 	= XInternAtom (dpy, "WM_DELETE_WINDOW", False);
  wm_protocols[1] 	= XInternAtom (dpy, "WM_SAVE_YOURSELF", False);
  xawtv_station 	= XInternAtom (dpy, "_XAWTV_STATION", False);
  xawtv_remote 		= XInternAtom (dpy, "_XAWTV_REMOTE", False);
  xa_deactivate 	= XInternAtom (dpy, "DEACTIVATE", False);

  xfree_xinerama_init(dpy);
  popuperror_init(app_context, app_shell);

  wm_detect(dpy);

  if (xfree_ext)
    xfree_init ();

  tv = video_init ();
  if(plugin && height_capture == -1) {
#ifdef HAVE_XV
    if(have_xv) height_capture = 576;
#endif
  }
  if(height_capture>0) height_capture_max = height_capture;
  if(width_capture>0) width_capture_max = width_capture;

  create_optwin ();
  create_chanwin ();
  create_editorwin ();
  if (plugin != NULL)
    plugin->create_windows(app_shell);

  idle_grabdisplay = idle_grabdisplay1;

  // Backup x11_pixmap_format in case of a plugin chages it
  divx_pixmap_format = x11_pixmap_format;

  XtVaGetValues (tv, XtNwidth, &w, NULL);
  if (!w)
    {
      fprintf (stderr, "The app-defaults file is not correctly installed.\n");
      fprintf (stderr,
               "You should have installed xawdecode by issuing \"make install\".\n");
      fprintf (stderr, "Your fault (core dumped).\n");
      fprintf (stderr, "(you can also temporarily do "
	       " \"cp Xawdecode.ad ~/Xawdecode\",\n"
	       "but do not forget to remove it when"
	       " xawdecode is installed correctly)\n");
      exit (1);
    }

  switch (bpp)
    {
    case 8:
      overlay_format = VIDEO_RGB08;
      break;
    case 15:
      overlay_format = VIDEO_RGB15;
      break;
    case 16:
      overlay_format = VIDEO_RGB16;
      break;
    case 24:
      overlay_format = VIDEO_RGB24;
      break;
    case 32:
      overlay_format = VIDEO_RGB32;
      break;
    default:
      overlay_format = x11_native_format;
    }

#ifdef HAVE_ALSA
  if(have_alsa==-1)
    have_alsa = 0;
  else
    have_alsa = check_alsa();
#endif

  grabber_init ();

  if (plugin != NULL)
    plugin->ui_init(app_context, app_shell, tv);

  if (plugin != NULL)
    plugin->set_idle_grabdisplay((void **)&idle_grabdisplay);

  /* Check for user directory */
  check_user_directory ();

  if (plugin != NULL)
    plugin->pre_config_init();

  /* read config file */
  if (!noconf)
    {
      read_config ();
      for(i=0;i<argc;i++) parse_opts(argc,argv,&i);
    }
  create_divxwin();
  create_divxaudiowin();
  create_streamparamswin();
  create_subpagewin ();
  create_alevtparamswin();
  create_xfreeparamswin();
  create_onscreen ();//xosd need config file...

  /* Ensure everything (MMX, fast_memcpy) is OK for deinterlacing */
  have_MMX = check_mmx();
  if (cmdline_probe_memcpy != -1)
    probe_fast_memcpy(MEMCPY_PROBE);
  else
    {
      load_memcpy_method();
      probe_fast_memcpy(memcpy_method);
    }

  if (plugin != NULL)
    plugin->post_config_init();

#ifdef HAVE_XV
  if (!have_xv)
    {
      deinterlace_list[1].nr  = -1;
      deinterlace_list[1].str = NULL;
    }
#endif

  set_capture_size(width_capture_max, height_capture_max);
  set_freqtab (chan_tab);
  channel_menu ();

  /* If mixer was not specified by config file, open it anyway */
  if (!have_mixer)
    {
      if (-1 != mixer_open ("/dev/mixer", mixer))
        have_mixer = 1;
    }


  if(grabbers[grabber] == &grab_avi) mixer_capture();
  if (have_mixer)
    cur_volume = mixer_get_volume ();

  set_volume ();
  cur_capture = 0;

  sprintf (modename, "%d x %d",
           XtScreen (app_shell)->width, XtScreen (app_shell)->height);
  switch (x11_native_format)
    {
    case VIDEO_RGB08:
      strcat (modename, " x 8 bit");
      break;
    case VIDEO_RGB15:
      strcat (modename, " x 15 bit");
      break;
    case VIDEO_RGB16:
      strcat (modename, " x 16 bit");
      break;
    case VIDEO_RGB24:
      strcat (modename, " x 24 bit");
      break;
    case VIDEO_RGB32:
      strcat (modename, " x 32 bit");
      break;
    }

  if (plugin != NULL)
    {
      // normally bpp is for overlay, the plugin also uses
      // anyway we dont use bpp in the following...
      if (-1 == plugin->init_colors(&bpp))
        return 1;
    }

#if 0
  strcat (modename, " - using ");
  strcat (modename, grabbers[grabber]->name);
#endif

#ifdef HAVE_XPM
  XpmCreatePixmapFromData(XtDisplay(app_shell),
                          RootWindowOfScreen(XtScreen(app_shell)),
                          icon_xpm,
                          &icon_pixmap,
                          &icon_shapemask, NULL);
  XtVaSetValues(app_shell, XtNiconPixmap, icon_pixmap, NULL);

  XpmCreatePixmapFromData(XtDisplay(opt_shell),
                          RootWindowOfScreen(XtScreen(opt_shell)),
                          icon_xpm,
                          &icon_pixmap,
                          &icon_shapemask, NULL);
  XtVaSetValues(opt_shell, XtNiconPixmap, icon_pixmap, NULL);
  XpmCreatePixmapFromData(XtDisplay(chan_shell),
                          RootWindowOfScreen(XtScreen(chan_shell)),
                          icon_xpm,
                          &icon_pixmap,
                          &icon_shapemask, NULL);
  XtVaSetValues(chan_shell, XtNiconPixmap, icon_pixmap, NULL);
#endif

  /* commandes externes */
  init_socket();

  if(subactive) set_subtitles_pageno(subtitles_pageno_str);
  if(subtitles_pageno_str) {
    int ns;
    ns = str_to_int(subtitles_pageno_str,subpageno_list);
    if(ns != -1) set_subpageno(ns);
  }

  /* lirc support */
  if (debug)
	fprintf(stderr,"main: checking for lirc ...\n");
  if (-1 != (lirc = lirc_tv_init()))
	XtAppAddInput(app_context,lirc,(XtPointer)XtInputReadMask,lirc_input,NULL);

  if(doublekey==-1) doublekey=count>10;

  if(doublekey && doublekey_firstisone==-1) {
    if(eventmap_checkfirstisone())
      doublekey_firstisone=1;
    else
      doublekey_firstisone= (count && channels[0]->key &&
			     (strcmp(channels[0]->key,"KP_1")==0  ||
			      strcmp(channels[0]->key,"KP_End")==0 ||
			      strcmp(channels[0]->key,"1")==0 ||
			      strcmp(channels[0]->key,"ampersand")==0));
  }

  XtRealizeWidget (app_shell);
  create_pointers (app_shell);
  create_bitmaps (app_shell);
  XDefineCursor (dpy, XtWindow (app_shell), left_ptr);
  XSetWMProtocols (XtDisplay (app_shell), XtWindow (app_shell),
                   wm_protocols, 2);

  XtVaSetValues (app_shell,
                 XtNwidthInc, WIDTH_INC,
                 XtNheightInc, HEIGHT_INC,
                 XtNminWidth, WIDTH_INC, XtNminHeight, HEIGHT_INC, NULL);

  if (optind + 1 == argc)
    {
      for (i = 0; i < count; i++)
        if (0 == strcasecmp (channels[i]->name, argv[optind]))
          cur_sender = i;
    }
  
  if(force_capture == -1) {
    if(grabbers[grabber] == &grab_avi 
#ifdef HAVE_BKTR
       || grabbers[grabber] == &grab_bktr
#endif
       )
      force_capture = CAPTURE_GRABDISPLAY;
#ifdef HAVE_VIDEO_XV
    if(grabbers[grabber] == &grab_xv)
      force_capture = CAPTURE_OVERLAY;
#endif
  }

  if(force_capture != -1) defaults.capture = force_capture;

  if (count)
    {
      if(force_capture != -1)
	for (i = 0; i < count; i++)
	  channels[i]->capture = force_capture;

      if ((load_last_channel(&last_channel)) == 0)
        {
	  if(force_capture != -1) last_channel.capture = force_capture;
	  
          for (i = 0; i < count; i++)
            if (channels[i]->freq==last_channel.freq && 
		channels[i]->norm==last_channel.norm &&
		channels[i]->source==last_channel.source &&
		strcmp(channels[i]->name,last_channel.name)==0)
            {
              cur_sender = i;
              break;
            }

          //memcpy(channels[i], &last_channel, sizeof(struct CHANNEL));
          if ((cur_sender < 0) || (cur_sender >= count)) {
            cur_sender = 0;
	    fprintf(stderr,"Warning: last channel not in xawdecoderc\n");
	  }
          else
            update_channel(channels[cur_sender],  &last_channel);
          set_channel (channels[cur_sender]);
          pixit();
        }
      else
        {
          if ((cur_sender < 0) || (cur_sender >= count))
            cur_sender = 0;
          set_channel (channels[cur_sender]);
        }
    }
  else
    {
      set_channel (&defaults);
    }

  if (fullscreen)
  {
    FullScreenAction (NULL, NULL, NULL, NULL);
    nodecoration = 0 ;
  }
  else
    XtAppAddWorkProc (app_context, MyResize, NULL);
  if (nomouse)
    PointerAction (NULL, NULL, NULL, NULL);

   if (nodecoration)
     DecorationAction (NULL, NULL, NULL, NULL);
   else
   {
   // if no window decoration requested,
   // the first OSD position is not in the window
     strcpy (title, modename);
     set_timer_title ();
   }
#ifdef USE_LIBXOSD
   if (libxosd && c_xosdaction)
     XtVaSetValues (c_xosdaction, XtNlabel, "Xosd             :      (On)     Ctrl+X", NULL);   
#endif
        
  if (!have_config)
    XtCallActionProc (tv, "Help", NULL, NULL, 0);
  if(cmd && !idle_id) XtAppAddWorkProc (app_context, docmd, NULL);
  XtAppMainLoop (app_context);

  /* keep compiler happy */
  return 0;
}

/*----------------------------------------------------------------------*/
/*--- END main function ------------------------------------------------*/
/*----------------------------------------------------------------------*/

